# Erik Arrhenius Troglo-AutoRig script 1.0

#made at TGA 2014
#----------------------------

   
import maya.cmds as cmds
import maya.mel as mel
import os
import sys
from xml.etree import cElementTree
from xml.dom import minidom
import xml.etree.ElementTree as ET
from functools import partial
userName= os.environ.get( "USERNAME" )
class TrogloAutorig:

    ctrlHierar=[None]
    ikCtrlList=[None]
    
    #----------------------------------------------
    #Definition to make Fix grps on selected object
    #----------------------------------------------
    def makeFix(self,*args): 
        newName=args
        newName=(newName[0].encode('ascii','ignore'))
        eaSelObject=cmds.ls(sl=1)
        eaP_Check=cmds.listRelatives(eaSelObject,parent=True)
        eaNull=cmds.group(n=str(eaSelObject[0])+"_null",em=True)
        cmds.parentConstraint(eaSelObject,eaNull,n="pCon",mo=False)
        cmds.delete("pCon")
        
        cmds.parent(eaSelObject,eaNull)
        try:
            cmds.parent(eaNull,eaP_Check)
            cmds.select(eaP_Check)
        except:
            pass
    #----------------------------------------------
    # Opens joint resize window
    #----------------------------------------------
    def jSizeWin(*args):
        mel.eval("jdsWin;")
    #-------------------------------------------------------------------
    #scales the Controls on setup, based on the joints starting length
    #-------------------------------------------------------------------
    def scaleByJointDistance(self,baseJoint,objToScale,magnitude,addativefactor):
        
        cmds.select(baseJoint)
        
        if baseJoint == "j_pelvis_bn":
            childCheck=["j_l_leg_bn"]
        
        else:   
            childCheck=cmds.listRelatives(c=True,type=("joint"))
            if not childCheck:
               childCheck=cmds.listRelatives(p=True,type=("joint"))
        
        mUnits=cmds.currentUnit(q=True)
        if mUnits =="0m":
            mag=1000
        elif mUnits=="cm":
            mag=100
        elif mUnits=="m":
            mag=1
        else:
            mag=10000
        #make temporary locators at , because distanceDimension only makes 1 locator if the distance is less than 0.14 units
        cmds.spaceLocator(n="tempLoc1")
        cmds.move(mag,0,0)
        cmds.spaceLocator(n="tempLoc2")
        cmds.move(-mag,0,0)
        myDist=cmds.distanceDimension(sp=(cmds.xform("tempLoc1",q=True,t=True,ws=True)),ep=(cmds.xform("tempLoc2",q=True,t=True,ws=True)) )
        dist1,dist2=cmds.listConnections(myDist)
        
        cmds.xform(dist1,t=(cmds.xform(baseJoint,q=True,t=True,ws=True)))
        cmds.xform(dist2,t=(cmds.xform(childCheck[0],q=True,t=True,ws=True)))
        
        cmds.select(myDist)
        cmds.pickWalk(d="up")
        myDistTransform=cmds.ls(sl=1)
        locs=cmds.listConnections(str(myDist))
        locs=[item for item in locs if "locator" in item]
        objLenght=cmds.getAttr(str(myDist)+".distance")
        if objLenght <= 0:
            objLenght=objLenght*-1
        else:
            pass
        if mUnits=="cm":
            pass
        elif mUnits=="m":
             magnitude=magnitude*0.01
        cmds.delete("tempLoc1","tempLoc2")     
        cmds.select(str(objToScale))    
        cmds.scale(((objLenght*float(magnitude)))+float(addativefactor),((objLenght*float(magnitude)))+float(addativefactor),((objLenght*float(magnitude)))+float(addativefactor))
    if cmds.objExists("eaTempNurb"):
        cmds.delete("eaTempNurb")
    else:
        pass
    
    #--------------------------------------------------------------
    #Make prefabs for ctrl shapes, based on what name the joint has
    #--------------------------------------------------------------
    def makeControl(self,*args):
        newName=args
        newName=(newName[0].encode('ascii','ignore'))
        try:
            childCheck=cmds.listRelatives(c=True,type=("joint"))
        except:
            pass
        sObj=cmds.ls(sl=1)
        spineCommand="curve -d 1 -p 0 0 0 -p 0 0 0 -p 0 0 -6 -p 1 0 -7 -p 2 0 -8 -p 2 0 -9 -p 1 0 -10 -p 0 0 -11 -p -1 0 -10 -p -2 0 -9 -p -2 0 -8 -p -1 0 -7 -p 0 0 -6 -p 0 0 -8 -p -2 0 -9 -p 2 0 -9 -p 0 0 -8 -p 1 0 -7 -p -1 0 -7 -p 0 0 -8 -p 0 0 -11 -k 0 -k 1 -k 2 -k 3 -k 4 -k 5 -k 6 -k 7 -k 8 -k 9 -k 10 -k 11 -k 12 -k 13 -k 14 -k 15 -k 16 -k 17 -k 18 -k 19 -k 20 ;"
        fkNormCommand="circle -c 0 0 0 -nr 1 0 0 -sw 360 -r 1 -d 3 -ut 0 -tol 0 -s 16 -ch 1;"
        clavicleCommand="circle -c 0 0 0 -nr 0 1 0 -sw 360 -r 1 -d 3 -ut 0 -tol 0 -s 8 -ch 1;"
        pelvisCommand="curve -d 1 -p -6 0 -1 -p 6 0 -1 -p 7 0 -2 -p 8 0 -2 -p 9 0 -1 -p 9 0 0 -p 8 0 1 -p 7 0 1 -p 6 0 0 -p -6 0 0 -p -7 0 1 -p -8 0 1 -p -9 0 0 -p -9 0 -1 -p -8 0 -2 -p -7 0 -2 -p -6 0 -1 -k 0 -k 1 -k 2 -k 3 -k 4 -k 5 -k 6 -k 7 -k 8 -k 9 -k 10 -k 11 -k 12 -k 13 -k 14 -k 15 -k 16 ;"
    
    
        if "spine" in str(sObj) and "End" in str(sObj):   
            newCtrlNode=mel.eval(spineCommand)
            
            cmds.rotate(-90,0,0)
            cmds.select(str(newCtrlNode)+".cv[0:20]")
            cmds.scale(0.5,0.5,0.5)
            cmds.makeIdentity(apply=True)
            self.scaleByJointDistance(str(sObj[0]),newCtrlNode,1.0,0.0)
            cmds.makeIdentity(apply=True)
            cmds.scale(0.7,1,1)
            cmds.makeIdentity(apply=True)
    
        elif "spine" in str(sObj) and "End" not in str(sObj):   
            newCtrlNode=mel.eval(spineCommand)
            cmds.rotate(-90,0,0)
            cmds.select(str(newCtrlNode)+".cv[0:20]")
            cmds.scale(1.0,1.0,1.0)
            cmds.makeIdentity(apply=True)
            self.scaleByJointDistance(str(sObj[0]),newCtrlNode,1.0,0.0)
            cmds.makeIdentity(apply=True)
            cmds.scale(0.7,1,1)
            cmds.makeIdentity(apply=True)
    
        elif "pelvis" in str(sObj):   
            newCtrlNode=mel.eval(pelvisCommand)
            cmds.move(0,0.5,0)
            cmds.rotate(-90,0,0)
            cmds.CenterPivot()
            cmds.makeIdentity(apply=True)
            self.scaleByJointDistance(str(sObj[0]),newCtrlNode,1.0,0.0)
            cmds.makeIdentity(apply=True)
            cmds.scale(0.5,0.5,0.5)
            cmds.makeIdentity(apply=True)
      
        elif "finger" in str(sObj):   
            newCtrlNode=mel.eval(spineCommand)
            if "_l_" in str(sObj):
                cmds.rotate(90,0,0)
            else:    
                cmds.rotate(-90,0,0)
            cmds.scale(0.3,0.3,0.3)
            cmds.makeIdentity(apply=True)
            if "End" not in str(sObj):  
                self.scaleByJointDistance(str(sObj[0]),newCtrlNode,1.0,0.01)
                cmds.makeIdentity(apply=True)
            else:
                pass
        elif "clavicle"in str(sObj):   
            newCtrlNode,newCtrlShape=mel.eval(clavicleCommand)
            newCtrlNode=cmds.rename("eaTempNurb")
            if "_r_" in str(sObj):         
    
                cmds.rotate(0,90,90)
            else:
                cmds.rotate(0,-90,90)    
            cmds.scale(2.0,2.0,2.0)
            mel.eval("select -r eaTempNurb.cv[2:4] ;move -r -os -wd 0.843032 0 0 ;scale -r -p 0cm -0.102871cm 0cm -3.597405 1 1 ;move -r -os -wd 0.271613 0 0 ;select -r eaTempNurb;select -r eaTempNurb.cv[0:7];move -r -os -wd 0 "+str(float(cmds.getAttr(str(childCheck[0])+'.translateX'))/-1.25)+" 0;select -r eaTempNurb")
            cmds.select("eaTempNurb.cv[0:7]")
            
            cmds.scale(2.1,2.1,2.1)
            cmds.makeIdentity(apply=True)        
            self.scaleByJointDistance(str(sObj[0]),newCtrlNode,1.0,0.0)
            
            cmds.setAttr(str(newCtrlNode)+".scaleY",1)
    
            cmds.makeIdentity(apply=True)
            cmds.scale(0.6,0.6,0.6)
        elif "root" in str(sObj):
            newCtrlNode=cmds.curve(d=1,p=[(-0.5, 0.201974, 0.5),(-0.5, 0.201974, -0.5) ,(0.5, 0.201974, -0.5) ,(0.5, 0.201974, 0.5) ,(-0.5, 0.201974, 0.5) ,(-0.5, -0.201974, 0.5) ,( 0.5, -0.201974, 0.5) ,(0.5, 0.201974, 0.5) ,(0.5, 0.201974, -0.5) ,(0.5, -0.201974, -0.5) ,(0.5, -0.201974, 0.5) ,(-0.5, -0.201974, 0.5) ,(-0.5, -0.201974 ,-0.5) ,(-0.5, 0.201974, -0.5) ,(0.5, 0.201974, -0.5) ,(0.5, -0.201974, -0.5) ,(-0.5, -0.201974, -0.5)],k= [0 ,1 , 2 ,3 , 4 , 5 , 6 , 7 ,8 , 9 ,10 , 11 , 12 ,13 , 14 ,15 , 16])
            cmds.rotate(0,0,90)
            cmds.select(str(newCtrlNode)+".cv[0:16]")
            cmds.scale(5.0,2.0,5.0)
            cmds.makeIdentity(apply=True)
            self.scaleByJointDistance(str(sObj[0]),newCtrlNode,1.0,0.1)
            cmds.makeIdentity(apply=True)          
        elif "chest" in str(sObj):
            newCtrlNode=cmds.curve(d=1,p=[(-0.5, 0.201974, 0.5),(-0.5, 0.201974, -0.5) ,(0.5, 0.201974, -0.5) ,(0.5, 0.201974, 0.5) ,(-0.5, 0.201974, 0.5) ,(-0.5, -0.201974, 0.5) ,( 0.5, -0.201974, 0.5) ,(0.5, 0.201974, 0.5) ,(0.5, 0.201974, -0.5) ,(0.5, -0.201974, -0.5) ,(0.5, -0.201974, 0.5) ,(-0.5, -0.201974, 0.5) ,(-0.5, -0.201974 ,-0.5) ,(-0.5, 0.201974, -0.5) ,(0.5, 0.201974, -0.5) ,(0.5, -0.201974, -0.5) ,(-0.5, -0.201974, -0.5)],k= [0 ,1 , 2 ,3 , 4 , 5 , 6 , 7 ,8 , 9 ,10 , 11 , 12 ,13 , 14 ,15 , 16])
            cmds.rotate(0,0,90) 
            cmds.scale(2.0,2.0,2.0)
            cmds.makeIdentity(apply=True)
            self.scaleByJointDistance(str(sObj[0]),newCtrlNode,1.0,0.1)
            cmds.makeIdentity(apply=True)
        elif "head" in str(sObj):
            newCtrlNode,newCtrlShape=mel.eval("circle -c 0 0 0 -nr 0 1 0 -sw 360 -r 1 -d 3 -ut 0 -tol 0 -s 8 -ch 1;")
            newCtrlNode=cmds.rename("eaTempNurb")
            mel.eval("select -r eaTempNurb.cv[4:6] ;move -r -os -wd 0 0 1.456452 ;scale -ws -r -p 0cm 23.399793cm 0.562668cm 1.443702 1 1 ;select -r eaTempNurb ;")
            cmds.makeIdentity(apply=True)
            cmds.rotate(0,90,0)
            cmds.select("eaTempNurb.cv[0:7]")
            cmds.scale(0.4,0.4,0.4)
            cmds.makeIdentity(apply=True)
            self.scaleByJointDistance(str(sObj[0]),newCtrlNode,1.0,0.0)
            cmds.makeIdentity(apply=True)        
        elif "ik_l_toe" in str(sObj) or "ik_r_toe" in str(sObj):
            newCtrlNode=cmds.curve(d=1,p=[(-0.5, 0.201974, 0.5),(-0.5, 0.201974, -0.5) ,(0.5, 0.201974, -0.5) ,(0.5, 0.201974, 0.5) ,(-0.5, 0.201974, 0.5) ,(-0.5, 0, 0.5) ,( 0.5, 0, 0.5) ,(0.5, 0.201974, 0.5) ,(0.5, 0.201974, -0.5) ,(0.5, 0, -0.5) ,(0.5, 0, 0.5) ,(-0.5, 0, 0.5) ,(-0.5, 0 ,-0.5) ,(-0.5, 0.201974, -0.5) ,(0.5, 0.201974, -0.5) ,(0.5, 0, -0.5) ,(-0.5, 0, -0.5)],k= [0 ,1 , 2 ,3 , 4 , 5 , 6 , 7 ,8 , 9 ,10 , 11 , 12 ,13 , 14 ,15 , 16])
            
            cmds.rotate(0,0,0)
            cmds.scale(2.0,2.0,2.0)
            cmds.makeIdentity(apply=True)
            self.scaleByJointDistance(str(sObj[0]),newCtrlNode,1.0,0.1)
        elif "ik_r_hand" in str(sObj) or "ik_l_hand" in str(sObj):
            newCtrlNode=cmds.curve(d=1,p=[(-0.5, 0.201974, 0.5),(-0.5, 0.201974, -0.5) ,(0.5, 0.201974, -0.5) ,(0.5, 0.201974, 0.5) ,(-0.5, 0.201974, 0.5) ,(-0.5, -0.201974, 0.5) ,( 0.5, -0.201974, 0.5) ,(0.5, 0.201974, 0.5) ,(0.5, 0.201974, -0.5) ,(0.5, -0.201974, -0.5) ,(0.5, -0.201974, 0.5) ,(-0.5, -0.201974, 0.5) ,(-0.5, -0.201974 ,-0.5) ,(-0.5, 0.201974, -0.5) ,(0.5, 0.201974, -0.5) ,(0.5, -0.201974, -0.5) ,(-0.5, -0.201974, -0.5)],k= [0 ,1 , 2 ,3 , 4 , 5 , 6 , 7 ,8 , 9 ,10 , 11 , 12 ,13 , 14 ,15 , 16])
            
            cmds.rotate(0,90,90)
            cmds.scale(2.0,1.0,2.0)
            cmds.makeIdentity(apply=True)
            self.scaleByJointDistance(str(sObj[0]),newCtrlNode,1.0,0.1)
            cmds.makeIdentity(apply=True)
        elif "shoulder" in str(sObj) or "leg" in str(sObj) or "knee" in str(sObj):
            newCtrlNode,newCtrlShape=mel.eval(fkNormCommand)
            cmds.select(str(newCtrlNode)+".cv[0:15]")
            cmds.scale(0.5,0.5,0.5)
            cmds.makeIdentity(apply=True)
            self.scaleByJointDistance(str(sObj[0]),newCtrlNode,1.0,0.0)
            cmds.makeIdentity(apply=True)
            
        elif "toe" in str(sObj) or "elbow" in str(sObj) or "knee" in str(sObj) :
            newCtrlNode,newCtrlShape=mel.eval(fkNormCommand)
            cmds.select(str(newCtrlNode)+".cv[0:15]")
            cmds.scale(1.1,1.1,1.1)
            cmds.makeIdentity(apply=True)
            self.scaleByJointDistance(str(sObj[0]),newCtrlNode,1.0,0.0)
            cmds.makeIdentity(apply=True)
    
        else:
            newCtrlNode,newCtrlShape=mel.eval(fkNormCommand)
            cmds.select(str(newCtrlNode)+".cv[0:15]")
            cmds.scale(1.5,1.5,1.5)
            cmds.makeIdentity(apply=True)
            self.scaleByJointDistance(str(sObj[0]),newCtrlNode,1.0,0.0)
            cmds.makeIdentity(apply=True)
        
            
        cmds.parentConstraint(sObj,newCtrlNode,n="sCon",mo=False)
        cmds.delete("sCon")
    
        cmds.rename(str(newCtrlNode),str(newName))
        cmds.select(str(newName))
        eaSelObject=cmds.ls(sl=1)
        eaP_Check=cmds.listRelatives(eaSelObject,parent=True)
        eaNull=cmds.group(n=str(eaSelObject[0])+"_null",em=True)
        cmds.parent(eaNull,eaSelObject)
        cmds.move(0,0,0,os=True)
        cmds.rotate(0,0,0,os=True)
        if eaP_Check != None:
            cmds.parent(eaNull,eaP_Check)
        else:
            cmds.parent(eaNull,w=True)
        cmds.parent(eaSelObject,eaNull)
        cmds.select(eaNull)
    #----------------------------------------------
    #creates polevectors on IK legs
    #----------------------------------------------        
    def poleVector(self):
        baseJt=cmds.ls(sl=1)
        jtIk=cmds.listConnections(type=("ikHandle"))
        childCheck=cmds.listRelatives(c=True,type="joint")
        topLoc=cmds.spaceLocator()
        botLoc=cmds.spaceLocator()
        cmds.parent(topLoc,baseJt)
        cmds.xform(os=True,ro=(0,0,0),t=(0,0,0))
        cmds.pointConstraint(childCheck,topLoc,mo=False,n="pLoc")
        cmds.delete("pLoc")
        cmds.parent(botLoc,childCheck)
        cmds.xform(os=True,ro=(0,0,0),t=(0,0,0))
        cmds.select(botLoc,topLoc)
        mag=cmds.getAttr("mainCtrl.scaleX")
        if "_r_shoulder" in baseJt[0] or "_l_leg_" in baseJt[0]:
            cmds.move(-10*mag,os=True,moveY=True)
        elif "_l_shoulder" in baseJt[0] or "_r_leg_" in baseJt[0]:
            cmds.move(10*mag,os=True,moveY=True)
        else:
            pass
        cmds.parent(botLoc,topLoc,w=True)
        poleVecLoc=cmds.spaceLocator(n=str(str(baseJt[0]).rsplit("j_")[-1]).rsplit("_bn")[0]+"_poleVector")
        cmds.parentConstraint(botLoc,topLoc,poleVecLoc,n="paLoc")
        cmds.delete(botLoc,topLoc,"paLoc")
        cmds.poleVectorConstraint(poleVecLoc,jtIk)
        
        self.makeFix(str(poleVecLoc[0]))
        
        cmds.select(clear=True)
    #----------------------------------------------
    #Deletes current Rig
    #----------------------------------------------    
    def delFunc(self,*args):
    
        optResult=cmds.confirmDialog(icn="question", title='Overwrite Maya Scene', message='Are you sure you want to delete the rig?, this action is undoable', button=['Yes','No'], defaultButton='Yes', cancelButton='No', dismissString='No' )
        if optResult=="Yes":
            try:
                if cmds.objExists("dontTouch_Grp"):
                    
                    cmds.delete("dontTouch_Grp","mainCtrl","l_leg_blend","r_leg_blend","l_shoulder_blend","r_shoulder_blend")
                    self.eaRigWinFunc()
                else:
                    try:
                        mel.eval("layerEditorSelectObjects jArrows;doDelete;layerEditorDeleteLayer jArrows")
                    except:
                        pass
                    cmds.delete("mainCtrl","j_root_bn","ik_r_HeelLoc","annoR","ik_l_HeelLoc","annoL")
                    self.eaRigWinFunc()
                if cmds.window("lockFkTransWin", ex = True):
                   cmds.deleteUI("lockFkTransWin")
            except:
                cmds.warning("Couldn't find a rig to delete")
        else:
            pass 
    #---------------------------------------------------
    #mirror joints position and rotation, from +X to -X
    #---------------------------------------------------
    def mirrorPos(self,*args):
        getRot=cmds.xform("mainCtrl",q=True,ro=True)
        
        cmds.xform("mainCtrl",ro=[0,0,0])
        pos=cmds.xform("ik_l_HeelLoc",q=True,t=True)
        rot=cmds.xform("ik_l_HeelLoc",q=True,ro=True)
        
        cmds.xform("ik_r_HeelLoc",ro=(rot[0]*-1,rot[1]*-1,rot[2]),t=(pos[0]*-1,pos[1],pos[2]))
        cmds.select("j_l_clavicle_bn","j_l_leg_bn")
        mirrorList = cmds.ls(sl=True)
        arrows=cmds.ls("*_Dir")
        arrowCtrls=[item for item in arrows if "_r_" in item]
        
        for i in mirrorList:
            mirroredJoint= str(i).rsplit("_l_")[0]+"_r_"+str(i).rsplit("_l_")[-1]
            
            if cmds.objExists(mirroredJoint):
                cmds.delete(mirroredJoint)
            else:
                pass            
            cmds.select(i)
            cmds.mirrorJoint(myz=True,mb=True,sr=('l_', 'r_'))
            cmds.select(clear=True)
        for i in arrowCtrls:
            cmds.parentConstraint(i.rsplit("_Dir")[0],i,n="pCon")
            cmds.delete("pCon")
        cmds.xform("mainCtrl",ro=getRot)   
    
    #----------------------------------------------
    #locking Attributes
    #----------------------------------------------
    def lockAttr(self,*args):
        eaAttr=cmds.ls(sl=1)
        for i in args:
            cmds.setAttr(str(eaAttr[0])+"."+str(i),lock=True)
    #----------------------------------------------
    #Unlocking Attributes
    #----------------------------------------------
    def unlockAttr(self,*args):
        eaAttr=cmds.ls(sl=1)
        for i in args:
            cmds.setAttr(str(eaAttr[0])+"."+str(i),lock=False)        
    #----------------------------------------------
    #creates a Scaleable copy of the skeleton
    #----------------------------------------------
    def scalePlacement(self,*args):
        cmds.parent("j_l_leg_bn","j_r_leg_bn","j_root_bn")
        cmds.parent("j_l_clavicle_bn","j_r_clavicle_bn","j_chest_bn")
        cmds.duplicate("j_root_bn")
        cmds.select("j_root_bn1")
        mel.eval('searchReplaceNames "j_" "scale_" "hierarchy";')
        cmds.rename("scale_root_bn1","scale_root_bn")
        cmds.parent("scale_root_bn","ik_l_HeelLoc","ik_r_HeelLoc","annoR","annoL",w=True)
        cmds.select("scale_root_bn")
        parentCheck=cmds.listRelatives(parent=True);cmds.pickWalk(d="up");cmds.scale(1,1,1)
        cmds.select("j_root_bn",hierarchy=True);jList=cmds.ls(sl=True)
    
        for i in jList:
            cmds.select(i)
            self.unlockAttr("ty","tz","ry","rx","rz")
            cmds.select("scale_"+str(i).rsplit("j_")[-1])
            self.unlockAttr("ty","tz","ry","rx","rz")
            cmds.parentConstraint(str(i),"scale_"+str(i).rsplit("j_")[-1],mo=False,n="pConScale")
        try:
            pass
            cmds.parent("scale_root_bn",w=True)
        except:
            pass
        cmds.delete(parentCheck)
            
    #------------------        
    #Basic skeletal Creation       
    #--------------------
    def jointPlacement(self,*args):
    
        if cmds.objExists("j_root_bn")==True:
     
            cmds.warning("a base rig already exists")
        else:
            cmds.checkBoxGrp('stretchField',edit=True,en2=True)
            currentPanel=cmds.getPanel(withFocus=True)
            if(cmds.getPanel(typeOf=currentPanel)=="modelPanel"):
                cmds.modelEditor(currentPanel,e=True,jointXray=True,)
            
            spineNum= cmds.intField("spineNum",q=True, v=True)
            fingerNum= cmds.intField("fingerNum",q=True, v=True)
            spineNum=(spineNum+1)  
            cmds.circle(n="mainCtrl", nr=(0, 1, 0), c=(0, 0, 0), sw=360, r=12)
            cmds.select(clear=True)    
            
            cmds.joint( p=(0 ,10.6 ,-0.4),n= "j_root_bn")
            cmds.joint("j_root_bn",edit=True,orientation=[90,0,90]) 
            for i in range(spineNum-1):
        
                if i == spineNum-2:
                    spineEndJ = cmds.joint( p=(0 ,(((14.9-10.6)/(spineNum))*(i+1)+10.6) ,-0.400),n= "j_spineEnd_bn")        
                
                else:
                    spineEndJ = cmds.joint( p=(0 ,(((14.9-10.6)/(spineNum))*(i+1)+10.6) ,-0.400),n= "j_spine"+str(i+1)+"_bn")
            
            
            
            cmds.select(clear=True)
            cmds.joint( p=(0 ,10.6 ,-0.4),n= "j_pelvis_bn")
            cmds.hide("j_pelvis_bn")
            cmds.parent("j_pelvis_bn","j_root_bn")
            cmds.select(clear=True)
            
            
            cmds.joint( p=(0 ,15.900 ,-0.400),n= "j_chest_bn")
            cmds.joint( p=(0 ,16.956 ,-0.400),n= "j_neck_bn")       
            cmds.joint( p=(0 ,18.656 ,-0.2),n= "j_head_bn")
            cmds.joint( p=(0 ,19.9 ,0),n= "j_head_jt") 
            cmds.select(clear=True)
            cmds.joint( p=(1.5 ,17.3 ,-0.5),n= "j_l_clavicle_bn")
            cmds.joint( p=(2.584 ,17.192 ,-0.501),n= "j_l_shoulder_bn")  
            cmds.joint( p=(4.485 ,13.304 ,-0.866),n= "j_l_elbow_bn")
            cmds.joint( p=(6.002 ,10.080 ,-0.175),n= "j_l_hand_bn")
            
            for i in range(fingerNum):
        
                cmds.joint( p=(6.228 ,9.643 ,-0.064),n= "j_l_finger"+str(i)+"Base_bn")  
                cmds.joint( p=(6.440 ,9.200 ,0.048),n= "j_l_finger"+str(i)+"Mid_bn")   
                cmds.joint( p=(6.288 ,8.883 ,0.127),n= "j_l_finger"+str(i)+"End_jt")
                cmds.select("j_l_hand_bn")   
            
            cmds.select(clear=True)
            if cmds.checkBox("legBox",q=True, v=True)==True:
                cmds.joint( p=(1.298 ,10.5 ,-0.503),n= "j_l_leg_bn")
                cmds.joint( p=(1.266 ,5.821 ,1.072),n= "j_l_knee_bn")
                cmds.joint( p=(1.247 ,3.32 ,-0.867),n= "j_l_metatarsus_bn")    
                cmds.joint( p=(1.247 ,1.172 ,-0.903),n= "j_l_foot_bn")
                cmds.joint( p=(1.255 ,0.486 ,-0.039),n= "j_l_toe_bn")
                cmds.joint( p=(1.271 ,0.288 ,1.493),n= "j_l_tip_jt")        
    
            else:
                
                cmds.joint( p=(1 ,10.5 ,-0.5),n= "j_l_leg_bn")
                cmds.joint( p=(1.18 ,6.31 ,0.5),n= "j_l_knee_bn")    
                cmds.joint( p=(1.4 ,1.2 ,-0.7),n= "j_l_foot_bn")
                cmds.joint( p=(1.487 ,0.56 ,0.16),n= "j_l_toe_bn")
                cmds.joint( p=(1.6 ,0.56 ,1.7),n= "j_l_tip_jt")   
        
            wristCheck=cmds.checkBox("wristBox",q=True,v=True)
            if wristCheck== True:
                
                cmds.insertJoint("j_l_elbow_bn")
                cmds.rename("j_l_wrist_bn")
                cmds.joint("j_l_wrist_bn",edit=True,co=True,p=(5.268,11.655,-0.511))
            else:
                pass
            
            fingerList=[]
            jList=cmds.ls('j_*',type="joint")
            cmds.select(clear=True)
    
            for i in jList:
                
                if "root" not in i:
                    cmds.select(i)
                    child=cmds.listRelatives(i,c=True)
                    cmds.setAttr(str(i)+".overrideEnabled", 1) 
                    cmds.setAttr(str(i)+".overrideColor", 14) 
                    if "spine" in i or "shoulder" in i or "Mid" in i:
                        self.lockAttr("tz","ty")
                        cmds.setAttr(str(i)+".overrideEnabled", 1) 
                        cmds.setAttr(str(i)+".overrideColor", 17) 
                    if "Base" in i:
                        fingerList.append([i])
                        cmds.setAttr(str(i)+".overrideEnabled", 1) 
                        cmds.setAttr(str(i)+".overrideColor", 14) 
                    if "hand"!= i:
                        try:
                            cmds.joint(edit=True,oj="xzy",secondaryAxisOrient="xup") 
                        except:
                            pass
                    if "finger" in i:
                        pass
                elif "root" in i:
                    cmds.setAttr(str(i)+".overrideEnabled", 1) 
                    cmds.setAttr(str(i)+".overrideColor", 14)  
            for i in range(fingerNum):
                mag=(float(fingerNum)*0.5)*0.25
                xPos=(float(i)/fingerNum)-mag
                
                cmds.select(fingerList[i])
                cmds.move(0.824,xPos,0,os=True)
    
            cmds.parent("j_l_leg_bn","j_root_bn");cmds.parent("j_l_clavicle_bn","j_chest_bn")
            cmds.parent("j_chest_bn",str(spineEndJ))           
            cmds.spaceLocator(n="ik_l_HeelLoc")
            cmds.xform(t=(1.322,0,-2.092),ro=(-180,-85.803,0))
            
            cmds.spaceLocator(n="ik_r_HeelLoc")     
            cmds.xform(t=(-1.322,0,-2.092),ro=(0,85.803,0))
            cmds.annotate( 'ik_r_HeelLoc', tx='Place at back-edge of heel', p=(-8, 6, -5) )
            cmds.rename("annoR")
            cmds.annotate( 'ik_l_HeelLoc', tx='Place at back-edge of heel', p=(8, 6, -5) )
            cmds.rename("annoL")
            cmds.select(clear=True)
            
            for i in jList:
                if "hand" in i or "jt" in i:
                    cmds.select(i)
                    cmds.joint(edit=True,o=(0,0,0))
                    self.lockAttr("tz","ty")
                    cmds.setAttr(str(i)+".overrideEnabled", 1) 
                    cmds.setAttr(str(i)+".overrideColor", 17) 
                elif "metatarsus" in i:
                    cmds.select(i)
                    self.lockAttr("tz","ty","rx","ry")
                    cmds.setAttr(str(i)+".overrideEnabled", 1) 
                    cmds.setAttr(str(i)+".overrideColor", 13) 
                elif "wrist" in i:
                    cmds.select(i)
                    cmds.joint(edit=True,o=(0,0,0))
                    self.lockAttr("tz","ty","rx","ry","rz")
                    cmds.setAttr(str(i)+".overrideEnabled", 1) 
                    cmds.setAttr(str(i)+".overrideColor", 16) 
                elif "foot" in i:
                    cmds.select(i)
                    self.lockAttr("tz","ty")
                    cmds.setAttr(str(i)+".overrideEnabled", 1) 
                    cmds.setAttr(str(i)+".overrideColor", 17) 
                elif "toe" in i or  "head" in i:
                    cmds.select(i)
                    rJoint=cmds.ls(sl=1)
                    cmds.setAttr(str(rJoint[0])+".jointOrientX",0);cmds.setAttr(str(rJoint[0])+".jointOrientY",0)
                    cmds.setAttr(str(i)+".overrideEnabled", 1) 
                    cmds.setAttr(str(i)+".overrideColor", 17) 
                    self.lockAttr("tz","ty")
                elif "elbow" in i or "knee" in i:
                    cmds.select(i)
                    rJoint=cmds.ls(sl=1)
                    cmds.setAttr(str(rJoint[0])+".jointOrientX",0);cmds.setAttr(str(rJoint[0])+".jointOrientY",0)
                    self.lockAttr("tz","ty","ry","rx")
                    cmds.setAttr(str(i)+".overrideEnabled", 1) 
                    cmds.setAttr(str(i)+".overrideColor", 13)  
                elif "neck" in i:
                    cmds.select(i)
                    rJoint=cmds.ls(sl=1)
                    cmds.setAttr(str(rJoint[0])+".jointOrientX",0);cmds.setAttr(str(rJoint[0])+".jointOrientY",0)
                    cmds.setAttr(str(i)+".overrideEnabled", 1) 
                    cmds.setAttr(str(i)+".overrideColor", 14) 
                elif "finger" in i:              
                    
                    cmds.select(i)
                    child=cmds.listRelatives(i,c=True)
                    if child:                   
                        cmds.joint(edit=True,oj="xyz",secondaryAxisOrient="xup")
                    else:
                        cmds.joint(edit=True,o=(0,0,0))
                        
                    if "Mid" in i:
                        cmds.setAttr(str(i)+".overrideEnabled", 1) 
                        cmds.setAttr(str(i)+".overrideColor", 13) 
                        jOrientX,jOrientY,jOrientZ=cmds.joint(query=True,o=True)
                        
                        cmds.joint(edit=True,o=(0,0,jOrientZ))
                        self.lockAttr("ry","rx") 
                    else:
                        pass    
                    
        
                else:
                    pass
            cmds.select(clear=True)
            cmds.parent("j_root_bn","ik_l_HeelLoc","ik_r_HeelLoc","annoR","annoL","mainCtrl")
            cmds.button("ctrlB",edit=True,enable=True)
            cmds.button("jtPosB",edit=True,enable=False)
            cmds.button("mirrorB",edit=True,enable=True)
            cmds.intField("spineNum",edit=True,enable=False)
            cmds.button("loadPreset",edit=True,enable=False)
            cmds.intField("fingerNum",edit=True,enable=False)
            cmds.checkBoxGrp("stretchField",edit=True,en1=True)
            cmds.checkBox("wristBox",edit=True,enable=False)
            cmds.checkBox("legBox",edit=True,enable=False)
            cmds.button("deleteB",edit=True,enable=True)
            
            self.mirrorPos()
            cmds.select(clear=True)
            cmds.createDisplayLayer(n="jArrows")
            mel.eval("layerEditorLayerButtonTypeChange jArrows;layerEditorLayerButtonTypeChange jArrows;")
            
            cmds.select("j_root_bn",hierarchy=True)
            njList=cmds.ls(sl=True)
            for i in njList:
                if "finger" in i and "End" not in i:
                    mel.eval('curve -d 1 -p 0 0 0 -p 0 0 -4 -p 1 0 -4 -p 0 0 -5 -p -1 0 -4 -p 0 0 -4 -k 0 -k 1 -k 2 -k 3 -k 4 -k 5;')
                    cmds.rename("eaTempCurve")
                    cmds.select("eaTempCurve.cv[4]")
                    cmds.select("eaTempCurve.cv[2]",tgl=True)
                    cmds.move(0, 0, 0.460284,r=True, os=True, wd=True)
                    cmds.select("eaTempCurve",r=True)
                    cmds.rotate(90, 0, 0,os=True )
                    cmds.makeIdentity(apply=True,t=1,r=1,s=1,n=0)
                    cmds.rename(str(i)+"_Dir")
                    cmds.scale(0.1,0.1,0.1)
                    cmds.rename(str(i)+"_Dir")
                    cmds.scale(0.1,0.1,0.1)
                    if "l" in i:
                       cmds.rotate(0,0,0)
                       cmds.makeIdentity(apply=True)
                    elif "r" in i:
                       cmds.rotate(180,0,0)
                       cmds.makeIdentity(apply=True)
                    mel.eval("editDisplayLayerMembers -noRecurse jArrows `ls -selection`;")
                    fingerDir=cmds.ls(sl=1)
                    cmds.parent(fingerDir,"mainCtrl")
                    cmds.parentConstraint(i,fingerDir,mo=False)
                    cmds.select(clear=True)
                elif "finger" in i and "End" in i:
                    cmds.setAttr(str(i)+".overrideEnabled", 1) 
                    cmds.setAttr(str(i)+".overrideColor", 13)
                    cmds.setAttr(str(i)+".jointOrientX", 0)
                    cmds.setAttr(str(i)+".jointOrientY", 0)
                    cmds.setAttr(str(i)+".jointOrientZ", 0)
            
            
            cmds.spaceLocator(n="headLoc")
            cmds.scale(0,0,0)
            cmds.parentConstraint("j_head_bn","headLoc",mo=False)
            cmds.annotate("headLoc" , point=[13.582, 27.805, -5], text="place at end of neck ,where neck connects to head")
            cmds.rename("annoH")        
             
            cmds.spaceLocator(n="neckLoc")
            cmds.scale(0,0,0)
            cmds.parentConstraint("j_neck_bn","neckLoc",mo=False)
            cmds.annotate("neckLoc" , point=[13.582, 24.805, -5], text="place at start of neck")
            cmds.rename("annoN")
            cmds.spaceLocator(n="chestLoc")
           
            cmds.scale(0,0,0)
            cmds.parentConstraint("j_chest_bn","chestLoc",mo=False)
            cmds.annotate("chestLoc" , point=[13.582, 21.258, -5], text="place at middle of chest") 
            cmds.rename("annoC")   
            
            cmds.parent("j_l_leg_bn","j_r_leg_bn","j_l_clavicle_bn","j_r_clavicle_bn","neckLoc","chestLoc","headLoc","annoH","annoN","annoC","mainCtrl")
            
    
            
            cmds.select(clear=True)
    
      
    #-------------------------
    #proxyMesh Creation  
    #-------------------------   
    def proxySetup(self):
        
        cmds.select("j_root_bn",hierarchy=True)
        proxyList=cmds.ls(sl=1)
        proxyGrp=cmds.group(n="proxyGrp",empty=True)
        for i in proxyList:
            
            
            addFactor=0
            if "root" not in i or "chest" not in i:
                try:
                    childCheck=cmds.listRelatives(str(i),children=True)
                    if float(cmds.getAttr(str(childCheck[0])+'.translateX'))<0:
                        addFactor=-0.3
                    elif float(cmds.getAttr(str(childCheck[0])+'.translateX'))>0:
                        addFactor=0.3
                except:
                    pass
                if childCheck==None:
                    pass
                else:
                    
                    #connect scale attributes instead, when scaling is available
                    proxyCube,proxyShape=cmds.polyCube(n=str(i).rsplit("bn")[0]+"proxy")
                    cmds.scale(1,(float(cmds.getAttr(str(childCheck[0])+'.translateX'))*0.1)+addFactor,(float(cmds.getAttr(str(childCheck[0])+'.translateX'))*0.1)+addFactor)
                    cmds.makeIdentity(apply=True)
                    cmds.pointConstraint(str(i),childCheck[0],proxyCube,mo=False);cmds.orientConstraint(str(i),proxyCube,mo=False)
                    cmds.connectAttr(str(childCheck[0])+'.translateX',str(proxyCube)+".scaleX")
                    cmds.parent(proxyCube,proxyGrp)
            else:
                pass
        cmds.addAttr("mainCtrl",ln="proxy_visibility",at="bool",k=True)
        cmds.connectAttr("mainCtrl.proxy_visibility","proxyGrp.visibility")    
    
    #----------------------
    #FK Ctrl Setup
    #----------------------
    
    def fkJoints(self,*args):
        #try to not create spine or clavicles
        cmds.select("j_root_bn",hierarchy=True)
        
        for i in cmds.ls(sl=1):
            cmds.select(i)
            try:
                self.unlockAttr("ty","tz","ry","rx")
            except:
                pass
        
        #duplicate joints and rename
        cmds.select("j_root_bn")
        cmds.duplicate(n="fk_root_bn")
        cmds.select(hierarchy=True)
     
        command = "searchReplaceNames \"j_\" \"fk_\" \"selected\" "
        mel.eval(command)
        fkList=cmds.ls(type="joint",sl=True)
        fkPos =[]
    
        for i in fkList: 
            if "wrist" in i or "spine" in i or "chest" in i or "head" in i  or "neck" in i or "root" in i or "clavicle" in i:   
                pass
            else:
                fkPos.append(i)     
        
        for i in fkPos:
            parentCheck = cmds.listRelatives(i, parent=True)
            if "wrist" in parentCheck[0]:
                parentCheck = cmds.listRelatives(parentCheck, parent=True)   
            parentCheck=str(parentCheck).replace("']","");parentCheck=str(parentCheck).replace("[u'","")        
            childCheck = cmds.listRelatives(i, children=True)        
            childCheck=str(childCheck).replace("']","");childCheck=str(childCheck).replace("[u'","") 
            #create custom controlls based on joint type, spine, arm etc
            
            if parentCheck != "None" and childCheck != "None":
      
                
                cmds.select(i)
                
                self.makeControl(str(i)[:-2]+"ctrl")
                
                if "finger" not in i:
                    cmds.orientConstraint(str(i)[:-2]+"ctrl",i,mo=False)
                else:
                    pass
                fixGrp=cmds.ls(sl=1)
    
                try:
                    cmds.parent(fixGrp,parentCheck[:-2]+"ctrl")
                except:
                    pass
                if cmds.objExists(str(i).rsplit("hand")[0]+"wrist"+str(i).rsplit("hand")[-1]) and "hand" in i:     
                   vari1=str(i).rsplit("hand")[0]+"wrist"+str(i).rsplit("hand")[-1]+".rotateX"
                   vari2=str(i).rsplit("bn")[0]+"ctrl.rotateX "
                   cmds.expression(s=str(vari1)+'='+str(vari2)+'*0.5' )
            else:
                pass 
        return fkPos
        cmds.select(clear=True)
    #--------------------
    #IK CTRL Setup
    #------------------
    def ikJoints(self,*args):
        cmds.select("j_root_bn")
        cmds.duplicate(n="ik_root_bn")
        cmds.showHidden(a=True)
        cmds.select(hierarchy=True)
        command = "searchReplaceNames \"j_\" \"ik_\" \"selected\" "
        mel.eval(command)
        ikList=cmds.ls(type="joint",sl=True) 
        
        cmds.select("ik_l_shoulder_bn","ik_r_shoulder_bn","ik_l_leg_bn","ik_r_leg_bn")
        armList = cmds.ls(sl=True)
        for i in armList:
            cmds.select(i)
            wristCheck=False
            cmds.select(hierarchy=True)
            wristCheckList = cmds.ls(sl=True,type="joint")
            myIk,myEffector2=cmds.ikHandle( sj=i, ee=wristCheckList[2], p=2, sol="ikRPsolver",n=str(i).rsplit("_bn")[0]+"Handle")
            cmds.select(i)
            self.poleVector()
            
            for i in wristCheckList:
                 if "wrist" in i:
                     wristCheck=True
                 elif "hand" in i:
                     cmds.select(i)
                     handPos=cmds.ls(sl=True)
                     handPos=cmds.xform(handPos,q=True,t=True,ws=True)
                     self.makeControl(str(i).rsplit("_bn")[0]+"_ctrl")
                 elif "toe" in i:
                     #setup foot ctrl, do parent and child check
                     
                     cmds.select(i)
                     toeJ=cmds.ls(sl=True)
                     
                     parentCheck=cmds.listRelatives(parent=True,type="joint")
                     childCheck=cmds.listRelatives(children=True,type="joint")
                     
                     self.makeControl(str(i).rsplit("toe_bn")[0]+"FootCtrl")
                     
                     cmds.addAttr(str(i).rsplit("toe_bn")[0]+"FootCtrl",dv=0,longName="toeTap",keyable=True)
                     cmds.addAttr(str(i).rsplit("toe_bn")[0]+"FootCtrl",dv=0,longName="toeStand",keyable=True)
                     cmds.addAttr(str(i).rsplit("toe_bn")[0]+"FootCtrl",dv=0,longName="heelRoll",keyable=True)
                     if cmds.checkBox("legBox",q=True,v=True) == True:
                         cmds.addAttr(str(i).rsplit("toe_bn")[0]+"FootCtrl",dv=0,longName="metatarsusRoll",keyable=True)
                     else:
                         pass
                     cmds.addAttr(str(i).rsplit("toe_bn")[0]+"FootCtrl",dv=0,longName="ballRoll",keyable=True)
                      
                     cmds.pickWalk(d="up")
                     footNull=cmds.ls(sl=1)
                     #cmds.DeleteHistory()
                     
                     cmds.move(cmds.xform(childCheck,q=True,t=True,ws=True)[1],y=True,ws=True)
                     
                     cmds.aimConstraint(childCheck,footNull,offset=(0,90,0),aimVector=(0,0,1),upVector=(0,1,0),worldUpType="vector",n="aCon")
                     cmds.delete("aCon")
                     cmds.select(footNull)
                     cmds.move(0,ws=True,moveY=True)
    
                     #sc handles
    
                     cmds.select(parentCheck,toeJ)
                     footHandle=cmds.ikHandle(solver="ikSCsolver",n=str(i).rsplit("toe_bn")[0]+"ballHandle")        
                     cmds.select(toeJ,childCheck[0])
                     toeHandle=cmds.ikHandle(solver="ikSCsolver",n=str(i).rsplit("toe_bn")[0]+"toeHandle")
                     grandparent=cmds.listRelatives(parentCheck,p=True)
                     
                     if cmds.checkBox("legBox",q=True,v=True) == True:
                         cmds.select(grandparent,parentCheck)
                         metatarsusHandle=cmds.ikHandle(solver="ikSCsolver",n=str(i).rsplit("toe_bn")[0]+"metatarsusHandle")
                     else:
                         pass
                     
                     
                     #customGroups
                     
                     toeStandGrp=cmds.group(em=True,n=str(i).rsplit("toe_bn")[0]+"toeStandGrp")
                     toeTapGrp=cmds.group(em=True,n=str(i).rsplit("toe_bn")[0]+"toeTapGrp")
                     heelRollGrp=cmds.group(em=True,n=str(i).rsplit("toe_bn")[0]+"heelRollGrp")
                     
                     if cmds.checkBox("legBox",q=True,v=True) == True:
                         metatarsusGrp=cmds.group(em=True,n=str(i).rsplit("toe_bn")[0]+"metatarsusGrp")
                     else:
                         pass       
                     ballRollGrp=cmds.group(em=True,n=str(i).rsplit("toe_bn")[0]+"ballRollGrp")
                     
                     cmds.parentConstraint(childCheck,toeStandGrp,n="gCon1")
                     cmds.parentConstraint(toeJ,toeTapGrp,n="gCon2")
                     cmds.parentConstraint(toeJ,ballRollGrp,n="gCon3")
                     if cmds.checkBox("legBox",q=True,v=True) == True:
                         cmds.parentConstraint(parentCheck,metatarsusGrp,n="gCon5",mo=False)
                     else:
                         pass
                     cmds.parentConstraint(str(i).rsplit("toe_bn")[0]+"HeelLoc",heelRollGrp,n="gCon4")
                     cmds.delete("gCon1","gCon2","gCon3","gCon4")
                     if cmds.checkBox("legBox",q=True,v=True) == True:
                         cmds.delete("gCon5")
                     else:
                         pass
                     
                     cmds.select(toeStandGrp)
                     self.makeFix("toeStand")
                     cmds.select(toeTapGrp)
                     self.makeFix("toeTapGrp")          
                     cmds.select(heelRollGrp)
                     self.makeFix("heelRollGrp")
                     cmds.select(ballRollGrp)
                     self.makeFix("ballRollGrp")
                     if cmds.checkBox("legBox",q=True,v=True) == True:
                         cmds.select(metatarsusGrp)
                         self.makeFix("metatarsusGrp")
                     else:
                         pass                    
                     # rotate heel locators in place
                     if "_r_" in str(i): 
                         cmds.aimConstraint(toeJ,str(i).rsplit("toe_bn")[0]+"HeelLoc",n="aCon",offset=(0,90,0),aimVector=(0,0,1),upVector=(0,1,0),worldUpType="vector")
                         cmds.select("ik_r_HeelLoc")
                         preTrans=cmds.xform(q=True,t=True,ws=True)
                         cmds.move(cmds.xform(str(i),q=True,t=True,ws=True)[1],y=True,ws=True)
                         cmds.delete("aCon")
                         cmds.rotate(0,rotateXZ=True) 
                         cmds.xform(t=preTrans)
                         cmds.parent("ik_r_shoulder_poleVector_null","mainCtrl")
                         cmds.parent("ik_r_HeelLoc","ik_r_leg_poleVector_null","ik_r_FootCtrl")
                         cmds.parent("ik_r_shoulderHandle","ik_r_hand_ctrl")
                         cmds.orientConstraint("ik_r_hand_ctrl","ik_r_hand_bn",mo=True)
                         cmds.clear=True
                         
                     elif "_l_" in str(i): 
                         cmds.aimConstraint(toeJ,str(i).rsplit("toe_bn")[0]+"HeelLoc",n="aCon", offset=(0,-90,0),aimVector=(0,0,1),upVector=(0,1,0),worldUpType="vector",worldUpVector=(0,1,0))
                         cmds.select("ik_l_HeelLoc")
                         preTrans=cmds.xform(q=True,t=True,ws=True)
                         cmds.move(cmds.xform(str(i),q=True,t=True,ws=True)[1],y=True,ws=True)
                         cmds.delete("aCon")
                         cmds.rotate(0,rotateXZ=True)
                         cmds.xform(t=preTrans)
                         cmds.parent("ik_l_shoulder_poleVector_null","mainCtrl")
                         cmds.parent("ik_l_HeelLoc","ik_l_leg_poleVector_null","ik_l_FootCtrl")
                         cmds.parent("ik_l_shoulderHandle","ik_l_hand_ctrl")
                         
                         cmds.pointConstraint("ik_l_HeelLoc","ik_l_heelRollGrp_null",mo=False)
                         cmds.orientConstraint("ik_l_HeelLoc","ik_l_heelRollGrp_null")
                         cmds.orientConstraint("ik_l_hand_ctrl","ik_l_hand_bn",mo=True)
                         cmds.clear=True
                     else:
                         pass
                     
                     cmds.parent(str(i).rsplit("toe_bn")[0]+"toeHandle",str(i).rsplit("toe_bn")[0]+"toeTapGrp")
                     cmds.parent(str(i).rsplit("toe_bn")[0]+"legHandle",str(i).rsplit("toe_bn")[0]+"ballRollGrp")     
    
                     cmds.parent(str(i).rsplit("toe_bn")[0]+"ballRollGrp_null",str(i).rsplit("toe_bn")[0]+"ballHandle",str(i).rsplit("toe_bn")[0]+"toeStandGrp")
                     if cmds.checkBox("legBox",q=True,v=True) == True:
                         cmds.parent(str(i).rsplit("toe_bn")[0]+"metatarsusHandle",str(i).rsplit("toe_bn")[0]+"legHandle",str(i).rsplit("toe_bn")[0]+"metatarsusGrp")
                         cmds.parent(str(i).rsplit("toe_bn")[0]+"metatarsusGrp_null",str(i).rsplit("toe_bn")[0]+"ballRollGrp")
                     else:
                         pass  
                     cmds.parent(str(i).rsplit("toe_bn")[0]+"toeTapGrp_null",str(i).rsplit("toe_bn")[0]+"toeStandGrp")
                     cmds.parent(str(i).rsplit("toe_bn")[0]+"toeStandGrp_null",str(i).rsplit("toe_bn")[0]+"heelRollGrp") 
                     cmds.parent(str(i).rsplit("toe_bn")[0]+"heelRollGrp_null",str(i).rsplit("toe_bn")[0]+"FootCtrl") 
                                                
                     cmds.connectAttr(str(i).rsplit("toe_bn")[0]+"FootCtrl.toeTap",str(i).rsplit("toe_bn")[0]+"toeTapGrp.rotateZ",f=True)
                     cmds.connectAttr(str(i).rsplit("toe_bn")[0]+"FootCtrl.toeStand",str(i).rsplit("toe_bn")[0]+"toeStandGrp.rotateZ",f=True)
                     cmds.connectAttr(str(i).rsplit("toe_bn")[0]+"FootCtrl.heelRoll",str(i).rsplit("toe_bn")[0]+"heelRollGrp.rotateZ",f=True)
                     cmds.connectAttr(str(i).rsplit("toe_bn")[0]+"FootCtrl.ballRoll",str(i).rsplit("toe_bn")[0]+"ballRollGrp.rotateZ",f=True)
                     if cmds.checkBox("legBox",q=True,v=True) == True:
                         #connect a reverse mpde for the rotate Z value
                         cmds.connectAttr(str(i).rsplit("toe_bn")[0]+"FootCtrl.metatarsusRoll",str(i).rsplit("toe_bn")[0]+"metatarsusGrp.rotateZ",f=True)
                     else:
                         pass
                     
                 else:
                     pass
            
            #if conditions met try to move the effector to the joint below the wrist
            if wristCheck==True:
                
                cmds.select(wristCheckList[1])
                myBone,myEffector = cmds.listRelatives(children=True)
                
                boneChild = cmds.listRelatives(myBone,children=True)
                
                bonePos=cmds.xform(boneChild,q=True,t=True) 
                cmds.xform(myEffector,rp=bonePos,sp=bonePos)
                
                
                cmds.xform(myIk,t=handPos)
                vari1=str(boneChild[0]).rsplit("bn")[0]+"ctrl.rotateX";vari2=str(myBone)+".rotateX"
                cmds.expression( o=str(myBone)[0], s=str(vari2)+'='+str(vari1)+'*0.5' )
            else:
                pass
    
        
        cmds.select(clear=True)
    #--------------------------------------------------------------------
    #Creates the Spine ctrls and IKs based on how many joints in the spine
    #-------------------------------------------------------------------
    def spineSetup(self):
        spineNum = cmds.intField("spineNum",q=1,v=1)
        
        if spineNum >= 4:
            startLoc=cmds.spaceLocator(n="start")
            cmds.parentConstraint("j_root_bn",startLoc,mo=False)
            cmds.select("j_root_bn")
            self.makeControl("rootCtrl")
            
            cmds.parentConstraint("rootCtrl","j_root_bn",mo=False);cmds.parentConstraint("rootCtrl","ik_root_bn",mo=False)
            if spineNum % 2 != 0:
                midLoc=cmds.spaceLocator(n="mid")
                cmds.parentConstraint("j_spine"+str(spineNum/2+1)+"_bn",midLoc,mo=False)
                
                cmds.select("j_spine"+str(spineNum/2+1)+"_bn")
                self.makeControl("midCtrl")
            else:
                midLoc=cmds.spaceLocator(n="mid")
                cmds.parentConstraint("j_spine"+str(spineNum/2+1)+"_bn","j_spine"+str(spineNum/2)+"_bn",midLoc,mo=False)
                
                cmds.select("j_spine"+str(spineNum/2+1)+"_bn")
                self.makeControl("midCtrl")
                
            endLoc=cmds.spaceLocator(n="end")
            cmds.parentConstraint("j_spineEnd_bn",endLoc,mo=False)
            cmds.select("j_spineEnd_bn")
            self.makeControl("chestCtrl ")
      
            cmds.select("j_spineEnd_bn","j_chest_bn")
            cmds.ikHandle(solver="ikSCsolver",n="chestHandle");
            cmds.parent("chestHandle","chestCtrl")
            
            cmds.select("ik_spine1_bn","ik_spineEnd_bn")
            cmds.ikHandle(solver="ikSplineSolver",ns=2,parentCurve=False,scv=True,n="spineHandle")
                      
            inCurve,ikCurve=cmds.listConnections(c=True,type="nurbsCurve")
            cmds.select(str(ikCurve)+".cv[3:4]")
            tCluster,tClusterHandle=cmds.cluster(n="topClust")
            cmds.parent(tClusterHandle,"chestCtrl")
            
            cmds.select(str(ikCurve)+".cv[2]")
            mCluster,mClusterHandle=cmds.cluster(n="midClust")
            cmds.parent(mClusterHandle,"midCtrl")
                    
            cmds.select(str(ikCurve)+".cv[0:1]")
            bCluster,bClusterHandle=cmds.cluster(n="botClust")
            cmds.parent(bClusterHandle,"rootCtrl")
            
            cmds.parent("chestCtrl_null","midCtrl")
            cmds.parent("midCtrl_null","rootCtrl")
            
            cmds.rename(ikCurve,"spineCurve")
            
                    
            cmds.setAttr("spineHandle.dTwistControlEnable", 1);cmds.setAttr("spineHandle.dWorldUpType", 4)
            cmds.connectAttr("rootCtrl.worldMatrix","spineHandle.dWorldUpMatrix",force=True);cmds.connectAttr("chestCtrl.worldMatrix","spineHandle.dWorldUpMatrixEnd",force=True)
            
            for i in range(spineNum):
                if i == spineNum-1:
                    break
                else:       
                    cmds.parentConstraint("ik_spine"+str(i+1)+"_bn","j_spine"+str(i+1)+"_bn",mo=False)
    
        else:
            cmds.select("j_root_bn")
            cmds.select(hierarchy=True)
            regularSpineCtrl=cmds.ls(sl=1)
            prevObj="rootCtrl"
            for i in regularSpineCtrl:
                
                if cmds.nodeType(i)=="joint":
                    if "root" in i:
                        cmds.select(i)
                        self.makeControl(str(str(i).rsplit("_bn")[0]).rsplit("j_")[-1]+"Ctrl")
                        cmds.parentConstraint(str(str(i).rsplit("_bn")[0]).rsplit("j_")[-1]+"Ctrl",str(i))
                        prevObj =str(str(str(i).rsplit("_bn")[0]).rsplit("j_")[-1]+"Ctrl")
                    elif "chest" not in i and "End" not in i and "root" not in i:
                        cmds.select(i)
                        self.makeControl(str(str(i).rsplit("_bn")[0]).rsplit("j_")[-1]+"Ctrl")
                        cmds.parentConstraint(str(str(i).rsplit("_bn")[0]).rsplit("j_")[-1]+"Ctrl",str(i))
                        cmds.parent(str(str(i).rsplit("_bn")[0]).rsplit("j_")[-1]+"Ctrl_null",prevObj)
                        prevObj =str(str(str(i).rsplit("_bn")[0]).rsplit("j_")[-1]+"Ctrl")
                    elif "End" in i:
                        cmds.select(i)
                        self.makeControl("chestCtrl")
                        cmds.parentConstraint("chestCtrl",str(i))
                        cmds.parent("chestCtrl_null",prevObj)
                    else:
                        pass
                        break
    
        cmds.select("j_pelvis_bn")
        self.makeControl("pelvisCtrl")
        cmds.parentConstraint("pelvisCtrl","ik_pelvis_bn",mo=False)
        
        cmds.select("j_neck_bn",hierarchy=True)
        
        headCtrls=cmds.ls(sl=1)
        for i in headCtrls:
            if "_jt" not in i:
                cmds.select(i)
                self.makeControl(str(str(i).rsplit("_bn")[0]).rsplit("j_")[-1]+"_ctrl")
                cmds.pickWalk(d="down")
                hCtrl=cmds.ls(sl=1)
                cmds.orientConstraint(hCtrl[0],i,mo=False)
                cmds.select(clear=True)
            else:
                pass
    
    #----------------------------------------------
    #ik FK switch on legs and arms
    #----------------------------------------------
    def ikFkSwitch(self):
        mainScaleNumX=cmds.getAttr("mainCtrl.scaleX")
        cmds.select("ik_root_bn")
        cmds.select(hierarchy=True)
        ikList=cmds.ls(type="joint",sl=True)
        
        cmds.select("fk_root_bn")
        cmds.select(hierarchy=True)
        fkList=cmds.ls(type="joint",sl=True)
    
        cmds.select("j_root_bn")
        cmds.select(hierarchy=True)
        jList=cmds.ls(type="joint",sl=True)
        
        for i in range(len(jList)):
            
            if "root" in str(jList[i]) or "spine" in str(jList[i]) or "chest" in str(jList[i]) or "neck" in str(jList[i]) or "head" in str(jList[i]) or "clavicle" in str(jList[i]) or "finger" in str(jList[i]):
                pass    
            else:
                cmds.orientConstraint( fkList[i], ikList[i], jList[i], w=1)
            if "leg" in str(jList[i]) or "shoulder" in str(jList[i]):
                mel.eval("curve -d 1 -p -0.5 0.5 0.5 -p 0.5 0.5 0.5 -p 0.5 0.5 -0.5 -p -0.5 0.5 -0.5 -p -0.5 0.5 0.5 -p -0.5 -0.5 0.5 -p 0.5 -0.5 0.5 -p 0.5 0.5 0.5 -p 0.5 0.5 -0.5 -p 0.5 -0.5 -0.5 -p 0.5 -0.5 0.5 -p -0.5 -0.5 0.5 -p -0.5 -0.5 -0.5 -p 0.5 -0.5 -0.5 -p 0.5 0.5 -0.5 -p -0.5 0.5 -0.5 -p -0.5 -0.5 -0.5 -p -0.5 -0.5 0.5 -p -0.5 0.5 0.5 -k 0 -k 1 -k 2 -k 3 -k 4 -k 5 -k 6 -k 7 -k 8 -k 9 -k 10 -k 11 -k 12 -k 13 -k 14 -k 15 -k 16 -k 17 -k 18 ;")
                cmds.scale(mainScaleNumX,mainScaleNumX,mainScaleNumX)
                cmds.makeIdentity(apply=True,scale=True)
                cmds.rename(str(jList[i][2:-2])+"Switch")
                switchCube=cmds.ls(sl=1)
                cmds.pointConstraint(jList[i],switchCube[0],n="pCon")
                cmds.addAttr(shortName='ikFkSwitch', longName='ikFkSwitch', defaultValue=1.0, maxValue=1.0, minValue=0.0,keyable=True)
                cmds.delete("pCon")
                cmds.move(0,0,(-4*mainScaleNumX), r=True)
                cmds.parentConstraint(jList[i],switchCube[0],mo=True)
                mel.eval("shadingNode -asUtility blendColors;")
                cmds.setAttr("blendColors1.color2G",1)
                cmds.rename(str(jList[i][2:-2])+"blend")
                blendCol=cmds.ls(sl=True)
                blendCol=str(blendCol).replace("']","") 
                blendCol=str(blendCol).replace("[u'","") 
                cmds.connectAttr(str(switchCube[0])+".ikFkSwitch",str(blendCol)+".blender")
                cmds.select(switchCube)
                self.makeFix("null")
        #connect constraints to blend color  
        cmds.select("j_l_shoulder_bn","j_r_shoulder_bn","j_l_leg_bn","j_r_leg_bn")
        armList=cmds.ls(sl=1)
        for i in armList:
            cmds.select(i,hierarchy=True)
            steps=cmds.ls(sl=1)
    
            for j in steps:
                if "Constraint" in j:
                    conAttrs=cmds.listAttr(j,k=True)
                    for k in conAttrs:
                        if "fk" in k:
                            cmds.connectAttr(str(i[2:-2])+"blend.outputR",str(j)+"."+str(k))
                            if "leg" in j or "shoulder" in j:
                                cmds.connectAttr(str(i[2:-2])+"blend.outputR",str("fk"+str(j).rsplit("j")[-1]).rsplit("bn")[0]+"ctrl_null"+".visibility")
                                cmds.connectAttr(str(i[2:-2])+"blend.outputG",str("ik"+str(j).rsplit("j")[-1]).rsplit("bn")[0]+"poleVector_null"+".visibility")
                        elif "ik" in k:
                            cmds.connectAttr(str(i[2:-2])+"blend.outputG",str(j)+"."+str(k))
                            if "hand" in j:
                                cmds.connectAttr(str(i[2:-2])+"blend.outputG",str("ik"+str(j).rsplit("j")[-1]).rsplit("bn")[0]+"ctrl_null"+".visibility")  
                            elif "foot" in j:
                                cmds.connectAttr(str(i[2:-2])+"blend.outputG",str("ik"+str(j).rsplit("j")[-1]).rsplit("foot_bn")[0]+"FootCtrl_null"+".visibility")
                                
                        else:
                            pass
    #----------------------------------------------
    #setup for the clavicle joints
    #----------------------------------------------
    def clavicleSetup(self):
        cmds.select("j_l_clavicle_bn");self.makeControl("l_clavicleCtrl")
        cmds.select("j_r_clavicle_bn");self.makeControl("r_clavicleCtrl")
        cmds.select("j_l_clavicle_bn","j_l_shoulder_bn")
        cmds.ikHandle(solver="ikSCsolver",n="l_clavicleHandle")
        cmds.select("j_r_clavicle_bn","j_r_shoulder_bn")
        cmds.ikHandle(solver="ikSCsolver",n="r_clavicleHandle")
        cmds.parent("l_clavicleHandle","l_clavicleCtrl");cmds.parent("r_clavicleHandle","r_clavicleCtrl")
    
    #--------------------------------------------------------------
    #create finger controls based on if fingertips is checked or not and finger number
    #--------------------------------------------------------------
    def fingerCtrl(self):
            fingerTips=cmds.checkBoxGrp('stretchField',query=True,v2=True)
            #fingerTips=cmds.checkBox("fingerEnd",q=True,v=True)
            fingerList=cmds.ls(sl=1)
            for j in fingerList:           
                if not "End" in j: 
      
                    cmds.parentConstraint(str("fk"+str(j).rsplit("j")[-1]).rsplit("bn")[0]+"ctrl",str(j),mo=True)
                    if "Base" in j:
                        try:
                            cmds.delete("fk"+str(j).rsplit("j")[-1],"ik"+str(j).rsplit("j")[-1])
                        except:
                            pass
                else:
                    pass
                if fingerTips==False:
                   if "End" in j:
                       cmds.delete(j)
                elif fingerTips==True:
                   if "End" in j:
                       cmds.select(j)
                       midJ=cmds.listRelatives(parent=True)
                       
                       self.makeControl("fk_"+str(str(j).rsplit("jt")[0]).rsplit("j_")[-1]+"ctrl")
                       cmds.scale(0.3,0.3,0.3)
                       cmds.makeIdentity(apply=True,s=True)                 
                       cmds.parentConstraint("fk_"+str(str(j).rsplit("jt")[0]).rsplit("j_")[-1]+"ctrl",str(j),mo=True)
                       cmds.parent("fk_"+str(str(j).rsplit("jt")[0]).rsplit("j_")[-1]+"ctrl_null","fk_"+str(str(midJ[0]).rsplit("bn")[0]).rsplit("j_")[-1]+"ctrl")
    #----------------------------------------------
    #parents groups, nodes and joints correctly
    #----------------------------------------------
    def cleanUp(self):
        
        cmds.parent("r_clavicleCtrl_null","l_clavicleCtrl_null","chestCtrl")
        cmds.parent("head_ctrl_null","neck_ctrl")
        
        r_legGrp=cmds.group(n="r_legGrp",empty=True);cmds.parent("fk_r_leg_ctrl_null","fk_r_leg_bn","ik_r_leg_bn","r_legGrp")
        l_legGrp=cmds.group(n="l_legGrp",empty=True);cmds.parent("fk_l_leg_ctrl_null","fk_l_leg_bn","ik_l_leg_bn","l_legGrp")
        r_armGrp=cmds.group(n="r_armGrp",empty=True);cmds.parent("fk_r_shoulder_ctrl_null","fk_r_shoulder_bn","ik_r_shoulder_bn","r_armGrp")
        l_armGrp=cmds.group(n="l_armGrp",empty=True);cmds.parent("fk_l_shoulder_ctrl_null","fk_l_shoulder_bn","ik_l_shoulder_bn","l_armGrp")
        ikCtrlGrp=cmds.group(n="ikCtrlGrp",empty=True);cmds.parent("ik_r_FootCtrl_null","ik_l_FootCtrl_null","ik_r_hand_ctrl_null","ik_l_hand_ctrl_null","ik_root_bn",ikCtrlGrp)
        
        cmds.select(clear=True)
        cmds.delete("neckLoc","chestLoc","headLoc","annoH","annoN","annoC","annoL","annoR","fk_l_clavicle_bn","fk_r_clavicle_bn","ik_l_clavicle_bn","ik_r_clavicle_bn","fk_root_bn","ik_head_bn","j_pelvis_bn")
        cmds.select("dontTouch_Grp")
        dontTouch=cmds.ls(sl=1)
        fNum=cmds.intField("fingerNum",query=True,value=True)
        
        for i in range(fNum):
            cmds.parent("fk_l_finger"+str(i)+"Base_ctrl_null","l_armGrp")
            cmds.parentConstraint("j_l_hand_bn","fk_l_finger"+str(i)+"Base_ctrl_null",mo=True)
            cmds.parent("fk_r_finger"+str(i)+"Base_ctrl_null","r_armGrp")
            cmds.parentConstraint("j_r_hand_bn","fk_r_finger"+str(i)+"Base_ctrl_null",mo=True)
            
            cmds.select("j_l_finger"+str(i)+"Base_bn",hierarchy=True)
            self.fingerCtrl()
            cmds.select("j_r_finger"+str(i)+"Base_bn",hierarchy=True)
            self.fingerCtrl()
            
            cmds.select(clear=True)
    
        cmds.hide("ik_l_shoulderHandle","ik_r_shoulderHandle","l_clavicleHandle","r_clavicleHandle","ik_r_heelRollGrp","ik_l_heelRollGrp","dontTouch_Grp","fk_l_shoulder_bn","fk_r_shoulder_bn","ik_l_shoulder_bn","ik_r_shoulder_bn","fk_l_leg_bn","fk_r_leg_bn","ik_l_leg_bn","ik_r_leg_bn","ik_root_bn")
        if cmds.objExists("midClustHandle"):
            cmds.hide("chestHandle","midClustHandle","botClustHandle","topClustHandle")
            cmds.parent("start","mid","end","spineHandle","spineCurve","scale_root_bn",dontTouch)
        else:
            pass
    
        cmds.parent(l_armGrp,"neck_ctrl_null",r_armGrp,"chestCtrl")
        
        cmds.parent("r_leg_Switch_null","l_leg_Switch_null","r_shoulder_Switch_null","l_shoulder_Switch_null","rootCtrl_null",ikCtrlGrp,r_legGrp,l_legGrp,"j_root_bn","mainCtrl")
        if cmds.objExists("proxyGrp"):
            cmds.parent("proxyGrp","mainCtrl")
        else:
            pass
        cmds.pointConstraint("j_l_shoulder_bn",l_armGrp,n="l_shoulderCon",mo=True);cmds.pointConstraint("j_r_shoulder_bn",r_armGrp,n="r_shoulderCon",mo=True)
        cmds.delete("j_root_bn_parentConstraint1")
        cmds.parentConstraint("pelvisCtrl","j_root_bn",n="rootCon",mo=True)
        cmds.parentConstraint("pelvisCtrl",r_legGrp,n="r_legCon",mo=True)
        cmds.parentConstraint("pelvisCtrl",l_legGrp,n="l_legCon",mo=True)
    #----------------------------------------------
    #inits the Setup of all ctrls
    #----------------------------------------------
    def setupCtrls(self,*args):
        
        cmds.group(n="dontTouch_Grp",empty=True)
    
        cmds.select("j_l_foot_bn","j_r_foot_bn")
        self.unlockAttr("tz","ty")
        
        mel.eval("layerEditorSelectObjects jArrows;doDelete;layerEditorDeleteLayer jArrows")
        self.scalePlacement()
        proxySet=cmds.checkBoxGrp('stretchField',query=True,v1=True)
        
        cmds.select("j_root_bn",hierarchy=True)
        jList=cmds.ls(sl=True)
        
        for i in jList:
            if i !="j_root_bn": 
                cmds.select(i)
                posObj=cmds.ls(sl=True)
                parentObj=cmds.listRelatives(posObj,parent=True)
                childObj=cmds.listRelatives(posObj,children=True)
                cmds.spaceLocator(n="jPosLoc")
                cmds.parent("jPosLoc",parentObj[0])
                cmds.parentConstraint(posObj[0],"jPosLoc",n="pCon",mo=False)
                getRotX,getRotY,getRotZ=cmds.xform("jPosLoc",q=True,ro=True)
                cmds.delete("pCon","jPosLoc")
                cmds.setAttr(str(posObj[0])+".rotateX",0)
                cmds.setAttr(str(posObj[0])+".rotateY",0)
                cmds.setAttr(str(posObj[0])+".rotateZ",0)
                cmds.setAttr(str(posObj[0])+".jointOrientX",getRotX)
                cmds.setAttr(str(posObj[0])+".jointOrientY",getRotY)
                cmds.setAttr(str(posObj[0])+".jointOrientZ",getRotZ)
            print i
        cmds.button("bindB",edit=True,enable=True)
        cmds.button("ctrlB",edit=True,enable=False)
        cmds.button("mirrorB",edit=True,enable=False)    
        cmds.button("ctrlScale",edit=True,enable=False) 
        cmds.checkBoxGrp("stretchField",edit=True,en1=False)     
        cmds.checkBoxGrp("stretchField",edit=True,en2=False)
        cmds.button("savePreset",edit=True,enable=False)  
        self.fkJoints()
        self.ikJoints()
        self.spineSetup()
        self.ikFkSwitch()
        self.clavicleSetup()
        if proxySet:
          self.proxySetup()
          cmds.warning("proxyMesh implemented under main Ctrl")    
        else:
            pass
        self.cleanUp()
        cmds.parent("pelvisCtrl_null","rootCtrl")  
        cmds.xform("pelvisCtrl_null",t=(0,0,0),os=True)  
        self.ctrlHierar[0],self.ikCtrlList[0]=TrogloAutorig().lockFkTrans()
        currentPanel=cmds.getPanel(withFocus=True)
        if(cmds.getPanel(typeOf=currentPanel)=="modelPanel"):
            cmds.modelEditor(currentPanel,e=True,jointXray=False)
        
        for i in self.ctrlHierar[0]:
            if "l_" in i[2][0]:
                cmds.setAttr(i[2][0]+".overrideEnabled",1)
                cmds.setAttr(i[2][0]+".overrideColor",4)
            elif "r_" in i[2][0]:
                cmds.setAttr(i[2][0]+".overrideEnabled",1)
                cmds.setAttr(i[2][0]+".overrideColor",14)
            else:
                cmds.setAttr(i[2][0]+".overrideEnabled",1)
                cmds.setAttr(i[2][0]+".overrideColor",17)
        for i in self.ikCtrlList[0]:
            if "l_" in i[2][0]:
                cmds.setAttr(i[2][0]+".overrideEnabled",1)
                cmds.setAttr(i[2][0]+".overrideColor",4)
            elif "r_" in i[2][0]:
                cmds.setAttr(i[2][0]+".overrideEnabled",1)
                cmds.setAttr(i[2][0]+".overrideColor",14)
        cmds.select(clear=True)
    #----------------------------------------------
    #smoothbind selected meshes
    #----------------------------------------------
    def smoothBindFunc(self,*args):
        bindMesh=cmds.ls(sl=1)
        if not bindMesh or cmds.nodeType(bindMesh[0])!=("transform"):
            cmds.warning(str(userName)+", please select a suitable Mesh to skinbind")
        else:
            cmds.select(bindMesh)
            cmds.select("j_root_bn",tgl=True)
            cmds.skinCluster(mi=4,dr=4.0,bm=1,wd=0,sm=2,nw=1,ih=False)
            cmds.hide("j_root_bn")
    
    #-------------------------------------------------------------------------
    #window that lets you scale your controls mirrored, and confirm your scale
    #-------------------------------------------------------------------------
    def eaUserScaleConfirm(self,*args):
        
        cmds.deleteUI("lockFkTransWin")
        cmds.button("deleteB",edit=True,enable=True) 
        cmds.button("ctrlScale",edit=True,enable=True)
        currentPanel=cmds.getPanel(withFocus=True)
        if(cmds.getPanel(typeOf=currentPanel)=="modelPanel"):
            cmds.modelEditor(currentPanel,e=True,xray=False)
        
        mel.eval('setObjectPickMask "Surface" true; setObjectPickMask "Joint" true; setObjectPickMask "Marker" true;')   
        if cmds.window("lockFkTransWin", ex = True):
           cmds.deleteUI("lockFkTransWin")
        if cmds.objExists("botClustHandle"):
            cmds.parent("botClustHandle","rootCtrl")
        else:
            pass
        for i in self.ctrlHierar[0]:
            cmds.select(i[2])
            self.unlockAttr("rx","ry","rz")
            cmds.select(clear=True)
            if "_l_" in i[2][0] or "l_cl" in i[2][0]:
                myCon=cmds.listConnections(str(i[2][0]).replace('l_','r_'))
                if myCon==None:
                    myCon=["nothing"]
                
                for j in myCon:
                    if str(i[2][0]) in j:
                        cmds.disconnectAttr(str(i[2][0])+".s",str(i[2][0]).replace('l_','r_')+".s")
                    elif str(i[2][0]) not in j:
                        pass
                
                cmds.select(clear=True)
            if "root" in str(i[2]) or "clavicle" in str(i[2]):
    
                cmds.select(i[2])
                self.unlockAttr("tx","ty","tz","rx","ry","rz")
                cmds.select(clear=True)
            if "neck" in str(i[2]) or "mid" in str(i[2]) or "chest" in str(i[2]) or "head" in str(i[2]):
                cmds.select(i[2])
                self.unlockAttr("rx","ry","rz")
                cmds.select(clear=True)
            else:
                pass
            cmds.select(i[2])
            cmds.makeIdentity(apply=True,scale=True)
            cmds.bakePartialHistory(prePostDeformers=True )
            cmds.select(clear=True)
        for i in self.ctrlHierar[0]:
            cmds.parent(i[0],i[1])
            cmds.select(clear=True)
        cmds.setAttr("r_clavicleCtrl.scaleX",1)
        cmds.setAttr("r_clavicleCtrl.scaleY",1)
        cmds.setAttr("r_clavicleCtrl.scaleZ",1)
        cmds.setAttr("l_legCon.pelvisCtrlW0",1)
        cmds.setAttr("r_legCon.pelvisCtrlW0",1)  
        
            
        for i in self.ikCtrlList[0]:
            cmds.select(i[2])
            if "_l_" in i[2][0]:
                myCon=cmds.listConnections(str(i[2][0]).replace('l_','r_'))
                for j in myCon:
                    if str(i[2][0]) in j:
                        cmds.disconnectAttr(str(i[2][0])+".s",str(i[2][0]).replace('l_','r_')+".s")
                    else:
                        pass
                
                cmds.select(clear=True)
            cmds.select(i[2])
            cmds.makeIdentity(apply=True,scale=True)
            cmds.bakePartialHistory(prePostDeformers=True )
            self.unlockAttr("tx","ty","tz","rx","ry","rz")
            
            
            
            
            cmds.parent(i[0],i[1])
            
            
            ikChildren=cmds.listRelatives(str(i[2][0])+"_temp_grp",children=True) 
            cmds.parent(ikChildren,i[2])
            cmds.delete(str(i[2][0])+"_temp_grp",)
            cmds.select(clear=True)
           
        cmds.parent("arm_Grp","chestCtrl")
        
        cmds.setAttr("l_shoulder_Switch.ikFkSwitch",1)
        cmds.setAttr("r_shoulder_Switch.ikFkSwitch",1)
        cmds.setAttr("l_leg_Switch.ikFkSwitch",1)
        cmds.setAttr("r_leg_Switch.ikFkSwitch",1)
        
        cmds.select(clear=True)
    #----------------------------------------------
    #scale ctrls symetricly if scale mirrored is checked
    #----------------------------------------------
    def uniOn(self,*args):
        if cmds.checkBox("uniScale",q=True,v=True)==True:
            print "yay"
            for i in self.ctrlHierar[0]:
                
                if "_l_" in i[2][0] or "l_cl" in i[2][0]:
                    cmds.connectAttr( i[2][0]+'.s', str(i[2][0]).replace('l_','r_')+'.s' )
            for i in self.ikCtrlList[0]:
                
                if "_l_" in i[2][0]:
                    cmds.connectAttr( i[2][0]+'.s', str(i[2][0]).replace('l_','r_')+'.s' )
                    
        elif cmds.checkBox("uniScale",q=True,v=True)==False:
            print "nay"
            for i in self.ctrlHierar[0]:   
                if "_l_" in i[2][0] or "l_cl" in i[2][0]:
                    cmds.disconnectAttr(str(i[2][0])+".s",str(i[2][0]).replace('l_','r_')+".s")
            for i in self.ikCtrlList[0]:   
                if "_l_" in i[2][0]:
                    cmds.disconnectAttr(str(i[2][0])+".s",str(i[2][0]).replace('l_','r_')+".s")
    #----------------------------------------------
    #ctrl scale mode activated
    #----------------------------------------------
    def lockFkTrans(self,*args): 
        cmds.button("deleteB",edit=True,enable=False)  
        cmds.button("ctrlScale",edit=True,enable=False)
        
        cmds.setAttr("l_legCon.pelvisCtrlW0",0)
        cmds.setAttr("r_legCon.pelvisCtrlW0",0)  
        currentPanel=cmds.getPanel(withFocus=True)
        if(cmds.getPanel(typeOf=currentPanel)=="modelPanel"):
            cmds.modelEditor(currentPanel,e=True,xray=True,da="smoothShaded",wos=False)
        
        mel.eval('setObjectPickMask "Surface" false; setObjectPickMask "Joint" false; setObjectPickMask "Marker" false;')   
        if cmds.window("lockFkTransWin", ex = True):
           cmds.deleteUI("lockFkTransWin")
        cmds.warning("CTRL SCALE MODE ACTIVATED - use scale tool to re-shape your Ctrls")
        cmds.ScaleTool()
        cmds.window("lockFkTransWin", title = "Scale Controls Mode",widthHeight=(50,150), s = False,tbm=False)
        cmds.columnLayout(adjustableColumn=True)
        cmds.separator( height=10, style='none' )
        cmds.text("Troglo - Ctrl Scale Window")
        cmds.separator( height=15, style='double' )
        cmds.rowLayout(nc=2)
        cmds.checkBox("uniScale",label="Mirrored Scale",enable=True,v=False,onc=partial(self.uniOn),ofc=partial(self.uniOn))
        cmds.button("confirmB",label="Confirm Scale",bgc=[0.2,0.2,0.5],command=partial(self.eaUserScaleConfirm))
        cmds.setParent("..")
        cmds.separator( height=15, style='in' )
        cmds.columnLayout(w=200)
        ctrlHierarchyList=[]
        ikHierarchyList=[]
        ctrls=cmds.ls(type="transform")
        fkCtrls=[item for item in ctrls if "fk" in item and "trl" in item and "null" not in item and "grp" not in item and "Grp" not in item and "fix" not in item]
        fkCtrls.extend(["r_clavicleCtrl","l_clavicleCtrl","head_ctrl","chestCtrl","rootCtrl","neck_ctrl","pelvisCtrl"])
        if cmds.objExists("midCtrl"):
            fkCtrls.extend(["midCtrl"])
        ikCtrls=[item for item in ctrls if "ik" in item and "trl" in item and "null" not in item and "grp" not in item and "Grp" not in item and "fix" not in item]
        
        if cmds.objExists("botClustHandle"):
            cmds.parent("botClustHandle",w=True)
        else:
            pass
        cmds.setAttr("l_shoulder_Switch.ikFkSwitch",0)
        cmds.setAttr("r_shoulder_Switch.ikFkSwitch",0)
        cmds.setAttr("l_leg_Switch.ikFkSwitch",0)
        cmds.setAttr("r_leg_Switch.ikFkSwitch",0)
        for i in ikCtrls:
            cmds.select(i)
            myObj=cmds.ls(sl=1)
            myParent=cmds.listRelatives(str(i),parent=True)
            children=cmds.listRelatives(str(i),children=True)
            cmds.select(clear=True)  
            
            if cmds.objExists(str(i)+"_temp_grp"):
                cmds.parent(children,str(i))
                cmds.delete(str(i)+"_temp_grp")
            cmds.select(clear=True)    
            tempIkGrp=cmds.group(n=str(i)+"_temp_grp",empty=True)
            cmds.parent(tempIkGrp,str(i))
            cmds.move(0,0,0,os=True)
            cmds.rotate(0,0,0,os=True)
            for i in children:
                if "Shape" not in i:
                    cmds.parent(i,tempIkGrp)
            cmds.parent(tempIkGrp,w=True)
    
            cmds.select(myObj)
            try:
                cmds.select(myParent)
                myGrandParent=cmds.listRelatives(parent=True)
            except:
                myGrandParent="world"
                pass
            cmds.parent(myParent,w=True)    
            cmds.select(myObj)
            isLocked=cmds.getAttr(i+".scaleX",lock=True)
            item = [myParent,myGrandParent,myObj]
            
            
            ikHierarchyList.append(item)
            
            if isLocked==False:
                self.lockAttr("ty","tx","tz","rx","ry","rz")
            elif isLocked==True:
                print "already locked"
    
            cmds.select(clear=True)
        #do the same for fk controls
        for i in fkCtrls:
                cmds.select(i)
    
                myObj=cmds.ls(sl=1)
                myParent=cmds.listRelatives(parent=True)
                try:
                    cmds.select(myParent)
                    myGrandParent=cmds.listRelatives(parent=True)
                except:
                    myGrandParent="world"
                    pass
                cmds.parent(myParent,w=True)    
                cmds.select(myObj)
                isLocked=cmds.getAttr(i+".scaleX",lock=True)
                item = [myParent,myGrandParent,myObj]
                
                
                ctrlHierarchyList.append(item)
                
                if isLocked==False:
                    self.lockAttr("ty","tx","tz","rx","ry","rz")
                elif isLocked==True:
                    print "already locked"
        
        if cmds.objExists("arm_Grp"):
            cmds.parent("r_armGrp","l_armGrp","chestCtrl")
            if cmds.objExists("chestHandle"):
                cmds.parent("chestHandle","topClustHandle","chestCtrl")
            else:
                pass  
            cmds.delete("arm_Grp")
        armGrp=cmds.group(n="arm_Grp",empty=True)
        cmds.parent(armGrp,"chestCtrl")
        cmds.move(0,0,0,os=True)
        cmds.rotate(0,0,0,os=True)
        cmds.parent("r_armGrp","l_armGrp","arm_Grp")
        if cmds.objExists("chestHandle"):
            cmds.parent("chestHandle","topClustHandle","arm_Grp")
        cmds.parent(armGrp,w=True)
        
        cmds.showWindow("lockFkTransWin")
        return ctrlHierarchyList, ikHierarchyList
    #----------------------------------------------
    #load preset of pre-saved rig setup
    #----------------------------------------------
    def loadPreset(self,*args):
        if cmds.objExists("j_root_bn"):
            optResult=cmds.confirmDialog(icn="question", title='Overwrite Maya Scene', message='delete the current rig, in order to load new?', button=['Yes','No'], defaultButton='Yes', cancelButton='No', dismissString='No' )
            if optResult=="Yes":
    
                try:
                    if cmds.objExists("dontTouch_Grp"):
                        
                        cmds.delete("dontTouch_Grp","mainCtrl","l_leg_blend","r_leg_blend","l_shoulder_blend","r_shoulder_blend")
                        eaRigWinFunc()
                    else:
                        try:
                            mel.eval("layerEditorSelectObjects jArrows;doDelete;layerEditorDeleteLayer jArrows")
                        except:
                            pass
                        cmds.delete("mainCtrl","j_root_bn","ik_r_HeelLoc","annoR","ik_l_HeelLoc","annoL")
                        eaRigWinFunc()
                    if cmds.window("lockFkTransWin", ex = True):
                       cmds.deleteUI("lockFkTransWin")
                except:
                    cmds.warning("Couldn't find a rig to delete")
        else:    
        
            myLoadPath=cmds.fileDialog2(fm=1,startingDirectory =userPath+"/trogloRigPreset/", fileFilter="Maya Ascii (*.ma)")
            presetName=myLoadPath[0].rsplit("/")[-1].rsplit(".")[0]
            filePath=cmds.file(str(myLoadPath[0]),i=True,type="mayaAscii",ra=False,mergeNamespacesOnClash=False,namespace="temp",options="v=0;",pr=True)
            mel.eval('namespace -mv "'+"temp"+'" ":" -force;')
            cmds.namespace(rm="temp",dnc=True)
            #import presets from xml
            fileName =str(filePath.rsplit("/")[-1]).rsplit(".")[0]
            tree= ET.parse(userPath+"/trogloRigPreset/"+fileName+".xml")
            
            root = tree.getroot()
            
            print root.attrib
            
            rigDict=root.attrib
            
            for key in rigDict:
                if "Box" in key:
                    cmds.checkBox(str(key),edit=True,v=bool(rigDict[key]))
                elif "Num" in key:
                    cmds.intField(str(key),edit=True,v=int(rigDict[key]))
                else:
                    pass
                print key+" corresponds to "+rigDict[key]
                
            cmds.button("ctrlB",edit=True,enable=True)
            cmds.button("jtPosB",edit=True,enable=False)
            cmds.intField("spineNum",edit=True,enable=False)
            cmds.intField("fingerNum",edit=True,enable=False)
            cmds.checkBox("wristBox",edit=True,enable=False)
            cmds.button("mirrorB",edit=True,enable=True)
            cmds.checkBoxGrp("stretchField",edit=True,en1=True)
            cmds.checkBoxGrp("stretchField",edit=True,en2=True)
            cmds.checkBox("legBox",edit=True,enable=False)
            #cmds.button("exJ",edit=True,enable=True,bgc=(0.8,0.8,0.8))
            #cmds.intField("limbSpine",edit=True,ed=False)
    #----------------------------------------------
    #save current joint placement
    #----------------------------------------------
    def savePreset(*args):
        if cmds.objExists("j_root_bn")==False:
            cmds.error("There is no Valid rig in the scene to save")
        else:
            origName=cmds.file(q=True,sceneName=True)
            mySavePath=cmds.fileDialog2(fm=0,startingDirectory =userPath+"/trogloRigPreset/*ma", )
            cmds.file( rename=mySavePath[0].rsplit(".")[0]+".ma" )
            cmds.select("mainCtrl")
            fileName = cmds.file( exportSelected=True, type='mayaAscii')
            
            xmlPath = userPath+"/trogloRigPreset/"+str(fileName.rsplit("/")[-1]).rsplit(".")[0]+".xml"                
            
            print xmlPath
            #ModelViewer
            def prettify(elem):           
                rough_string = cElementTree.tostring(elem, 'utf-8')
                reparsed = minidom.parseString(rough_string)
                return '\n'.join([line for line in reparsed.toprettyxml(indent=' '*2).split('\n') if line.strip()])
            
            root = ET.Element("rigPreset")
            tree = ET.ElementTree(root)
            root.set("fingerNum",str(cmds.intField("fingerNum",q=True,v=True)))
            root.set("spineNum",str(cmds.intField("spineNum",q=True,v=True)))
            root.set("wristBox",str(cmds.checkBox("wristBox",q=True,v=True)))
            root.set("legBox",str(cmds.checkBox("legBox",q=True,v=True)))
            ET.tostring(root)
            
            '''modelViewerFilePath = ET.SubElement(root, "", path = animModelViewerColladaPath)
            '''
            output_file = open(xmlPath,'w')
            
            output_file.write(prettify(root))
            output_file.close()
            cmds.file(rename=origName)
    #----------------------------------
    #   Help Window
    #----------------------------------
    def eaHelpWinFunc(self,*args):   
        if cmds.window("eaHelpWin", ex = True):
           cmds.deleteUI("eaHelpWin")
        cmds.window("eaHelpWin", title = "Help - Troglo-AutoRig",widthHeight=(350,350), s = False)
        cmds.columnLayout(adjustableColumn=True)
        cmds.text("Troglo-AutoRig Script Quick guide",bgc=(0.3,0.3,0.3))
        
        cmds.columnLayout(adjustableColumn=True)
        cmds.separator(height=15,style="double")
        cmds.text("Step 1: Joint Setup",align="center",bgc=(0.3,0.3,0.3))
        cmds.separator(height=15,style="in")
        cmds.text("1. Make sure your model is facing positive Z for the best results.",align="left")
        cmds.separator(height=15,style="in")
        cmds.text("2. the wrist twist button gives  your arms an extra joint to roll deformation from.",align="left")    
        cmds.separator(height=15,style="in")
        cmds.text("3. the Digitigrade/plantigrade leg button, sets your character rig up with either goat shaped legs or human shaped.",align="left")    
        cmds.separator(height=15,style="in")
    
    
        cmds.rowLayout(nc=2,adjustableColumn=1)
        cmds.text("4. The probably most efficient and easiest workflow",align="left")
    
        cmds.setParent("..")
        cmds.rowLayout(nc=2,adjustableColumn=1)
        cmds.text("of positioning your joints with this script,\nis to translate and rotate the joints in a Hierarchy manner.",align="left")
    
        cmds.setParent("..")
        cmds.rowLayout(nc=2,adjustableColumn=1)
        cmds.text("Simply select the root joint, rotate and move it into position",align="left")
    
        cmds.setParent("..")
        cmds.rowLayout(nc=2,adjustableColumn=1)
        cmds.text("then continue down through the hierarchy with the next joint,\nposition it and continue down to the next joint in the hierarchy \nand so on...",align="left")
        cmds.setParent("..")
        cmds.separator(height=15,style="in")
        cmds.rowLayout(nc=2,adjustableColumn=2)
        cmds.text("5. Joint Color = Translate/Rotate limitations")
        cmds.text(" ")
        cmds.setParent("..")
        cmds.separator(height=15,style="none")
        cmds.rowLayout(nc=6,adjustableColumn=6)
        cmds.text("    ",align="right",bgc=(0,1,0))
        cmds.text("=")
        cmds.text("moves in XYZ, rotates in XYZ  ")
        cmds.text("    ",align="right",bgc=(1,1,0))
        cmds.text("=")
        cmds.text("moves in X, rotates in XYZ  ",align="left")    
        cmds.setParent("..")
        cmds.rowLayout(nc=6,adjustableColumn=6)
        cmds.text("    ",align="right",bgc=(1,0,0))
        cmds.text("=")
        cmds.text("moves in X, rotates in Z          ") 
        cmds.text("    ",align="right",bgc=(1,1,1))
        cmds.text("=")
        cmds.text("moves in X",align="left")       
        cmds.setParent("..")
        cmds.separator(height=15,style="in")
        
        cmds.text("6. the mirror placement button mirrors from positive X to negative X.\nThat means if you want a symetrical binding pose,\nwork on the left side of your characters joints first \nthen click the mirror button ",align="left")
        cmds.separator(height=15,style="in")
        cmds.text("7. If your model seems to big or small for the default joints created,\nfeel free to scale the joints,by selecting the MainCtrl nurbsCircle\nand with the scale tool reshape it accordingly",align="left")
        
        cmds.separator(height=15,style="double")
        cmds.text("Step 2: Control setup",align="center",bgc=(0.3,0.3,0.3))
        cmds.separator(height=15,style="in")
        cmds.text("1. when the setup excecutes, the scale control window opens.\nWithin this window you may scale each fk and Ik control, to match your models size.",align="left")
        cmds.separator(height=15,style="in")
        cmds.text("2. the proxy mesh option creates a box character based on the joints length,\nto optimize animation workflow , when working with high detailed characters.",align="left")
        cmds.separator(height=15,style="in")
        cmds.text("3. the cubes behind each arm and leg is its own ik/fk switch",align="left")
        cmds.separator(height=15,style="double")
        cmds.text("Step 3: Skinning",align="center",bgc=(0.3,0.3,0.3))
        cmds.separator(height=15,style="in")  
        cmds.text("1. select the meshes you wish to skin and click the smoothbind button",align="left")
        cmds.columnLayout(adjustableColumn=True)
        cmds.separator(height=15,style="double")
        cmds.text("Optional Step: loading/Saving presets",align="center",bgc=(0.3,0.3,0.3))
        cmds.separator(height=15,style="in")
        cmds.text("1. clicking save preset, saves the setup of your joint placement and not your control setups",align="left")
        cmds.separator(height=15,style="double")
        cmds.text("2. clicking load preset,lets you browse to the folder you saved a preset, If theres a preset saved on the computer",align="left")
        cmds.separator(height=15,style="double")
        cmds.text("For further question or feedback, feel freee to email me at ",align="left")
        cmds.text("erikarrhenius@gmail.com ",fn="boldLabelFont",align="left")
        cmds.setParent("..")
        cmds.separator(height=15,style="in")
        cmds.showWindow("eaHelpWin")       
    
    
    #---------------------------
    #    Main window
    #---------------------------
    def eaRigWinFunc(self):   
        
        
        if cmds.window("eaRigWin", ex = True):
           cmds.deleteUI("eaRigWin")
        cmds.window("eaRigWin", title = "Troglo-AutoRig",widthHeight=(350,350), s = False)
           
        cmds.columnLayout(adjustableColumn=True)
        cmds.separator( height=10, style='none' )
        cmds.rowLayout(nc=3,adjustableColumn=2)
        cmds.separator( height=10, style='in' )
        cmds.text("          version 1.0",align="center")
        cmds.button(label=" Help ",bgc=[0.2,0.2,0.2],command=partial(self.eaHelpWinFunc))
        cmds.setParent("..")
        cmds.separator( height=15, style='double' )
        cmds.text("Joint Setup")
        cmds.separator( height=15, style='in' )
        cmds.rowLayout(nc=7,adjustableColumn=1)
        cmds.button("loadPreset",label="Load preset...", command=partial(self.loadPreset),enable=True,bgc=(0.3,0.3,0.5))
        cmds.separator( width=2, style='none',hr=False )
        cmds.text("    number of spine joints   ")
        
        cmds.intField("spineNum",value=5,minValue=2,maxValue=100,w=30,enable=True)
        cmds.setParent("..")
        
        cmds.rowLayout(nc=4,adjustableColumn=1)
        cmds.button("savePreset",label="Save preset...", command=partial(self.savePreset),enable=True,bgc=(0.5,0.3,0.3))
        cmds.separator( width=35, style='none',hr=False )
        cmds.text("number of fingers   ",align="right")
        
        cmds.intField("fingerNum",value=5,minValue=1,maxValue=100,step=1,w=30,enable=True)
        cmds.setParent("..")
        
        cmds.rowLayout(nc=2,adjustableColumn=1)
        cmds.separator( height=25, style='none',hr=False )
        cmds.checkBox("wristBox",label="wrist/twist joint", v=True,enable=True)
        
        cmds.setParent("..")
        cmds.rowLayout(nc=2,adjustableColumn=1)
        cmds.separator( height=25, style='none',hr=False )
        cmds.checkBox("legBox",label="Digitigrade/Plantigrade leg", v=False,enable=True)
        
        cmds.setParent("..")
        cmds.rowLayout(nc=3,adjustableColumn=1)
        cmds.separator( height=1, style='none',hr=False )
        cmds.separator(height=1,style='none',hr=False)
        cmds.separator( width=22, style='none',hr=False )
        cmds.setParent("..")
        cmds.rowLayout(nc=3,adjustableColumn=2)
        cmds.button("jtPosB",label="Joint placement",command=partial(self.jointPlacement),enable=True)
        
        cmds.separator( height=25, style='none',hr=False )
        cmds.button("mirrorB",label="Mirror left arm/leg to right",command=partial(self.mirrorPos),enable=False)
        cmds.setParent("..")
           
        cmds.separator( height=15, style='double' )
        cmds.text("Control setup")
        cmds.separator( height=15, style='in' )
        cmds.rowLayout(nc=4,adjustableColumn=2)
        cmds.button("ctrlB",label="Setup controls", command=partial(TrogloAutorig().setupCtrls),enable=False)
        cmds.separator( height=46, style='in',hr=False )
        cmds.checkBoxGrp("stretchField",numberOfCheckBoxes=2,  labelArray2=[ 'Proxy mesh', 'FingerTips'] ,vr=True,en1=False,en2=False)
        cmds.setParent("..")
        
        cmds.columnLayout(adjustableColumn=True)
        cmds.separator( height=15, style='double' )
        cmds.text("Skinning")
        cmds.separator( height=15, style='in' )
        cmds.rowLayout(nc=3,adjustableColumn=2)
        cmds.button("bindB",label="Smoothbind",command=partial(self.smoothBindFunc),enable=False)
        
        cmds.separator( height=15, style='none',hr=False )
        cmds.setParent("..")
        cmds.separator( height=10, style='double' )
        
        cmds.rowLayout(nc=5,adjustableColumn=3)
        cmds.button("ctrlScale",label="Scale ctrls",bgc=[0.2,0.2,0.5],command=partial(self.lockFkTrans),enable=False)
        cmds.separator( width=5, style='none' )
        cmds.button("jSize",label="joint size",bgc=[0.5,0.45,0.1],command=partial(self.jSizeWin),enable=True)
        cmds.separator( width=5, style='none' )
        cmds.button("deleteB",label="Delete Rig",bgc=[0.5,0.2,0.2],command=partial(self.delFunc),enable=True)
        cmds.setParent("..")
        
        cmds.separator( height=8, style='double' )
        cmds.text("Current user: "+str(userName))
        cmds.showWindow("eaRigWin")
        
        
    #------------------------------------------------------
    #check if its the users first time running the script
    #-------------------------------------------------------
    def firstTimeUser(*args):
        myPath ="temp"
        for each in sys.path:
            if "maya" in each:
                if "scripts" in each:
                    myPath = each
        newpath = str(myPath+"/trogloRigPreset")
        if not os.path.exists(newpath):
            os.makedirs(newpath)
        if os.path.exists(myPath+"/trogloRigUser.txt") == True:
            print "already existing user"
            pass
        elif os.path.exists(myPath+"/trogloRigUser.txt") == False:
            print "file created"
            open(myPath+"/trogloRigUser.txt", "w")
    
            msg="Hello "+str(userName)+"\nif this is your first time Using the troglo-Autorig\nyou are strongly advised to view the Quick guide"
            myChoice=cmds.confirmDialog( title='Greetings', message=msg, button=['View Guide','No thanks'], defaultButton='Yes', cancelButton='No', dismissString='dismiss' )
            if myChoice =="View Guide":
                TrogloAutorig().eaHelpWinFunc()
            elif myChoice =='No thanks'or myChoice =='No' or myChoice =='dismiss':
                msg="remember "+str(userName)+"\nyou can view the guide anytime by pressing HELP \nin the upper right corner of the script"
                myChoice=cmds.confirmDialog( title='Friendly Reminder', message=msg, button=['OK'], defaultButton='Yes', cancelButton='No', dismissString='dismiss' )
        return myPath
        
     
userPath=TrogloAutorig().firstTimeUser()            
TrogloAutorig().eaRigWinFunc()